# The following script may be used to create the required tables in MySQL database

#
# Table structure for table "accounts"
#
DROP TABLE IF EXISTS accounts;
CREATE TABLE accounts (
  login varchar(255) NOT NULL,
  data blob NOT NULL,
  PRIMARY KEY  (login)
);


#
# Table structure for table "groups"
#
DROP TABLE IF EXISTS groups;
CREATE TABLE groups (
  name varchar(255) NOT NULL,
  data blob NOT NULL,
  PRIMARY KEY  (name)
);


#
# Table structure for table "log"
#
DROP TABLE IF EXISTS log;
CREATE TABLE log (
  id INT AUTO_INCREMENT NOT NULL,
  record_date timestamp NOT NULL,
  server_ip VARCHAR(255),
  server_port INT,
  client_ip VARCHAR(255),
  client_port INT,
  username VARCHAR(255),
  client_request VARCHAR(1024),
  client_message VARCHAR(1024),
  server_status VARCHAR(1024),
  server_message VARCHAR(1024),
  inbound_bytes BIGINT,
  outbound_bytes BIGINT,
  PRIMARY KEY  (id)
);


#
# Table structure for table "Transfer"
#
DROP TABLE IF EXISTS transfer;
CREATE TABLE transfer (
  id VARCHAR(255) NOT NULL, 
  username VARCHAR(255) NOT NULL, 
  transferDate TIMESTAMP NOT NULL, 
  data BLOB NOT NULL, 
  PRIMARY KEY(id)
);

