function Action(type, form) {
    this._constructor(type, form);
}(function() {

    Action.prototype = {

        type: null,
        form: null,

        _constructor: function(type, form) {
            this.type = type;
            this.form = form;
        },

        perform: function(parameters, target) {
            if (this.form == null) {
                document.location = "/action/" + this.type;
                return;
            }

            var inputs = [];
            parameters = arguments.length > 0 ? parameters : {};

            for (var name in parameters) {
                var input = this._findInputNamed(name, true);
                inputs.push(input);
                var values = [].concat(parameters[name]);
                while (values.length) {
                    input.value = values.shift();
                    if (values.length) {
                        input = this._cloneInput(input);
                        inputs.push(input);
                    }
                }
            }

            this.form.action = (/.*\/action\/$/.test(this.form.action) ? this.form.action : "/action/") + encodeURIComponent(this.type);
            this.form.target = target ? target : "";
            this.form.submit();

            this._cleanup(inputs);
        },

        _findInputNamed: function(name, create) {
            var elements = this.form.elements;
            for (var i = 0; i < elements.length; ++i) {
                if (elements[i].name == name) {
                    return elements[i];
                }
            }
            return create ? this._createInput(name) : null;
        },

        _cloneInput: function(input) {
            return this.form.appendChild(input.cloneNode(false));
        },

        _createInput: function(name) {
            return this.form.appendChild(Utils.createInput(Tag.INPUT_TYPE_HIDDEN, name));
        },

        _cleanup: function(inputs) {
            while (inputs.length) {
                this.form.removeChild(inputs.pop());
            }
        }
    }
})();