function KeyEvent(e) {
    this._constructor(e);
}(function() { // create local scope;

    KeyEvent.VK_ESCAPE = 27;
    KeyEvent.VK_TAB = 9;
    KeyEvent.VK_ENTER = 13;
    KeyEvent.VK_SPACE = 32;
    KeyEvent.VK_BACK_SPACE = 8;
    KeyEvent.VK_DELETE = 46;
    KeyEvent.VK_INSERT = 45;
    KeyEvent.VK_LEFT = 37;
    KeyEvent.VK_RIGHT = 39;
    KeyEvent.VK_UP = 38;
    KeyEvent.VK_DOWN = 40;
    KeyEvent.VK_HOME = 36;
    KeyEvent.VK_END = 35;
    KeyEvent.VK_PAGE_UP = 33;
    KeyEvent.VK_PAGE_DOWN = 34;
    KeyEvent.VK_F1 = 112;
    KeyEvent.VK_F2 = 113;
    KeyEvent.VK_F3 = 114;
    KeyEvent.VK_F4 = 115;
    KeyEvent.VK_F5 = 116;
    KeyEvent.VK_F6 = 117;
    KeyEvent.VK_F7 = 118;
    KeyEvent.VK_F8 = 119;
    KeyEvent.VK_F9 = 120;
    KeyEvent.VK_F10 = 121;
    KeyEvent.VK_F11 = 122;
    KeyEvent.VK_F12 = 123;

    KeyEvent.prototype = {

        event: null,
        source: null,
        keyCode: null,
        keyChar: null,
        canceled: null,

        _constructor: function(e) {
            this.event = e ? e : window.event;
            this.source = this.event.target ? this.event.target : (this.event.srcElement ? this.event.srcElement : null);
            this.keyCode = this.event.keyCode ? this.event.keyCode : (this.event.which ? this.event.which : 0);
            this.keyChar = this.event.type == 'keypress' ? String.fromCharCode(this.event.charCode ? this.event.charCode : this.event.keyCode) : "";
            this.canceled = false;
        },

        getKeyCode: function() {
            return this.keyCode;
        },

        getChar: function() {
            return this.keyChar;
        },

        getSource: function() {
            return this.source;
        },

        isCanceled: function() {
            return this.canceled;
        },

        cancel: function() {
            this.canceled = true;
            Event.stop(this.event);

            return false;
        },

        isAltDown: function() {
            return this.event.altKey;
        },

        isShiftDown: function() {
            return this.event.shiftKey;
        },

        isControlDown: function() {
            return this.event.ctrlKey;
        },

        isModifiersDown: function() {
            return (this.isAltDown() || this.isShiftDown() || this.isControlDown());
        }

    };

})();