var ChangeDirectoryDialog = Class.create(ModalDialog, {

    pathField: null,
    keyboardHandler: null,

    _constructor: function() {
        this.pathField = Utils.createTextInput("changePathInputField");
        this.pathField.setAttribute("size", 37);

        var content = this.getContent();
        content.appendChild(Utils.createLabel(ChangeDirectoryDialog.Labels.PATH, this.pathField.name));
        content.appendChild(this.pathField);

        this.addButton(ModalDialog.BUTTON_OK, ChangeDirectoryDialog.Buttons.OK);
        this.addButton(ModalDialog.BUTTON_CANCEL, ChangeDirectoryDialog.Buttons.CANCEL);
        this.setTitle(ChangeDirectoryDialog.TITLE);
        this.setSize(380, null);
    },

    getId: function() {
        return "ChangeDirectoryDialog";
    },

    show: function(listener) {
        this._update();
        this._super.show.call(this, Object.extend(new ChangeDirectoryDialog.Listener(), listener || {}));
    },

    onSubmit: function() {
        var path = $F(this.pathField) || "";
        this.listener.onChange(this, path);
    },

    onCancel: function() {
        this.dispose();
    },

    _valid: function() {
        var value = $F(this.pathField);
        return value && value.trim().length != 0;
    },

    _bindEvents: function() {
        this.keyboardHandler = this._update.bind(this);
        Event.observe(this.pathField, "keyup", this.keyboardHandler);
    },

    _unbindEvents: function() {
        Event.unobserve(this.pathField, "keyup", this.keyboardHandler);
        this.keyboardHandler = null;
    },

    _update: function() {
        this.setButtonEnabled(ModalDialog.BUTTON_OK, this._valid());
    },

    _requestFocus: function() {
        this._super._requestFocus.call(this, this.pathField);
    }
});
ChangeDirectoryDialog.TITLE = "Change Directory";
ChangeDirectoryDialog.Labels = {PATH: 'Path:'};
ChangeDirectoryDialog.Buttons = {OK: 'Change', CANCEL: 'Cancel'};
ChangeDirectoryDialog.Listener = Class.create(ModalDialog.Listener, {
    onChange: function(dialog, path) {}
});


var NewDirectoryDialog = Class.create(ModalDialog, {

    pathField: null,
    keyboardHandler: null,

    _constructor: function() {
        this.pathField = Utils.createTextInput("newDirInputField");

        var content = this.getContent();
        content.appendChild(Utils.createLabel(NewDirectoryDialog.Labels.NAME, this.pathField.name));
        content.appendChild(this.pathField);

        this.addButton(ModalDialog.BUTTON_OK, NewDirectoryDialog.Buttons.OK);
        this.addButton(ModalDialog.BUTTON_CANCEL, NewDirectoryDialog.Buttons.CANCEL);
        this.setTitle(NewDirectoryDialog.TITLE);
    },

    getId: function() {
        return "NewDirectoryDialog";
    },

    show: function(listener) {
        this._update();
        this._super.show.call(this, Object.extend(new NewDirectoryDialog.Listener(), listener || {}));
    },

    onSubmit: function() {
        var path = $F(this.pathField) || "";
        this.listener.onCreate(this, path);
    },

    onCancel: function() {
        this.dispose();
    },

    _valid: function() {
        var value = $F(this.pathField);
        return value && value.trim().length != 0;
    },

    _bindEvents: function() {
        this.keyboardHandler = this._update.bind(this);
        Event.observe(this.pathField, "keyup", this.keyboardHandler);
    },

    _unbindEvents: function() {
        Event.unobserve(this.pathField, "keyup", this.keyboardHandler);
        this.keyboardHandler = null;
    },

    _update: function() {
        this.setButtonEnabled(ModalDialog.BUTTON_OK, this._valid());
    },

    _requestFocus: function() {
        this._super._requestFocus.call(this, this.pathField);
    }
});
NewDirectoryDialog.TITLE = "New Directory";
NewDirectoryDialog.Labels = {NAME: 'New directory'};
NewDirectoryDialog.Buttons = {OK: 'OK', CANCEL: 'Cancel'};
NewDirectoryDialog.Listener = Class.create(ModalDialog.Listener, {
    onCreate: function(dialog, path) {}
});