function Table(table) {
    this._constructor(table);
}(function(){

    Table.prototype = {

        table: null,

        _constructor: function(table) {
            this.table = table;
            this._registerKeyEvents();
        },

        processKeyEvent: function(ke) {
            var code = ke.getKeyCode();

            switch (code) {
                case KeyEvent.VK_UP:
                    ke.cancel();
                    this._rowUp();
                    break;

                case KeyEvent.VK_DOWN:
                    ke.cancel();
                    this._rowDown();
                    break;

                case KeyEvent.VK_INSERT:
                    if (!ke.isModifiersDown()) {
                        ke.cancel();
                        markSelectedFile();
                        this._rowDown();
                    }
                    break;
            }
        },

        _rowUp: function() {
            rowUp();
            this._fireTableChanged();
        },

        _rowDown: function() {
            rowDown();
            this._fireTableChanged();
        },

        _fireTableChanged: function() {
            // todo:
            fireSelectionChanged();
        },

        _registerKeyEvents: function() {
            var km = KeyboardManager.getInstance();
            km.registerHandler(KeyEvent.VK_UP,  this);
            km.registerHandler(KeyEvent.VK_DOWN,  this);
            km.registerHandler(KeyEvent.VK_INSERT,  this);
        },

        _unregisterKeyEvents: function() {
            var km = KeyboardManager.getInstance();
            km.unregisterHandler(KeyEvent.VK_UP,  this);
            km.unregisterHandler(KeyEvent.VK_DOWN,  this);
            km.unregisterHandler(KeyEvent.VK_INSERT,  this);
        }
    }
})();