function InactivityPane(inactivityService) {
    this._constructor(inactivityService);
}
(function() {

    InactivityPane.Buttons = {WAKEUP: ""};
    InactivityPane.Messages = {REMINDER: ""};

    var CSS_CLASS = "dialogWindow";
    var GRACE_PERIOD_ID = "graceperiod";

    InactivityPane.prototype = {

        dialog: null,
        unitText: null,
        remainTime: null,
        lastRemainTime: null,

        _constructor: function(service) {
            this.dialog = new ModalDialog();
            this.dialog.useInactivityService = false;
            this.dialog.setCssClass(CSS_CLASS);
            this.dialog.addButton(ModalDialog.BUTTON_OK, InactivityPane.Buttons.WAKEUP, function() {service.restart(); });
            this.dialog.getContent().innerHTML = InactivityPane.Messages.REMINDER;
            this.dialog.setVisible(false);

            this.remainTime = $(GRACE_PERIOD_ID);
            this.unitText = this._getUnitText(Utils.getTextNode(this.remainTime));
        },

        setRemainSecond: function(second) {
            if (this.remainTime == null) {
                return;
            }

            var node = document.createTextNode(second + this.unitText);
            this.lastRemainTime = Utils.getTextNode(this.remainTime);

            if (this.lastRemainTime != null) {
                this.remainTime.replaceChild(node, this.lastRemainTime);
            } else {
                this.remainTime.appendChild(node);
            }
        },

        setVisible: function(visible) {
            this.dialog.setVisible(visible);
        },

        _getRemainTimeMessage: function(time) {
            var result = document.createTextNode(time);
            result.appendChild(this.unitText);
            return result;
        },

        _getUnitText: function(node) {
            var text = (node.nodeType == Node.TEXT) ? node.nodeValue : node.innerHTML;
            var time = parseInt(text);
            return isNaN(time) ? text : text.substring(String(time).length);
        }
    };
})();