<#ftl strip_whitespace=true>
<@compress single_line=true>
<#-- @ftlvariable name="property" type="com.jscape.util.reflection.PropertyDescriptor" -->
<#-- @ftlvariable name="field" type="com.jscape.util.reflection.types.ChoiceField" -->
<#-- @ftlvariable name="description" type="java.lang.String" -->
<#-- @ftlvariable name="example" type="java.lang.String" -->
<#assign fieldId=property.propertyName?html />
<#assign helpId="${fieldId}-help" />
<#if field.optional!false>
<div class="checkbox">
    <label><input type="checkbox" name="use${fieldId}"/>${property.label}<#if property.required><em>*</em></#if></label>
    <select
            id="${fieldId}"
            name="${fieldId}"
            data-options="editable:false,width:200"
            aria-describedby="${helpId}"
            <#if property.required> required="required"</#if>
            >
        <#list field.variants![] as item><option value="${item?html}">${item}</option></#list>
    </select>
    <#if property.postLabel?has_content>&nbsp;${property.postLabel}</#if>
    <span id="${helpId}" role="tooltip" class="help"><b>${property.label}</b><#if description?has_content><div>${description}</div></#if><#if example?has_content><div><b>Example:</b> ${example}</div></#if></span>
</div>
<#else>
<div>
    <label for="${fieldId}">${property.label}<#if property.required><em>*</em></#if></label>
    <select
            id="${fieldId}"
            name="${fieldId}"
            data-options="editable:true,width:200"
            aria-describedby="${helpId}"
            <#if property.required> required="required"</#if>
            >
        <#list field.variants![] as item><option value="${item?html}">${item}</option></#list>
    </select>
    <#if property.postLabel?has_content>&nbsp;${property.postLabel}</#if>
    <span id="${helpId}" role="tooltip" class="help"><b>${property.label}</b><#if description?has_content><div>${description}</div></#if><#if example?has_content><div><b>Example:</b> ${example}</div></#if></span>
</div>
</#if>
</@compress>