<#ftl strip_whitespace=true>
<#assign nextId=0 />

<#macro button name attrs...><a role="button" name="${name?html}" tabindex="0"<@_attributes attrs/>><#nested /></a></#macro>
<#macro label for="" required=false><#local body><#nested /></#local><#if body?has_content><label<#if for?has_content> for="${for?html}"</#if>>${body}<#if required?string == "true"><em>*</em></#if></label></#if></#macro>
<#macro checkbox name attrs...><#local is_checked=(attrs["checked"]!false)?string?matches("(true|checked)", "i")/><@label required=attrs["required"]><input type="checkbox" name="${name?html}"<#if is_checked> checked="checked"</#if><@_attributes items=attrs excludes=["type","required","checked"]/>/><#nested /></@label></#macro>
<#macro radio name attrs...><#local is_checked=(attrs["checked"]!false)?string?matches("(true|checked)", "i")/><@label required=attrs["required"]><input type="radio" name="${name?html}"<#if is_checked> checked="checked"</#if><@_attributes items=attrs excludes=["type","required","checked"]/>/><#nested /></@label></#macro>
<#macro input name attrs...><#local id=attrs["id"]!_nextId()/><@label for=id required=attrs["required"]><#nested /></@label><input type="${(attrs["type"]!"text")?html}" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type","required"]/>/></#macro>
<#macro select name items attrs...><#local id=attrs["id"]!_nextId()/><#local body><#nested /></#local><#local options><#if items?is_hash_ex><#list items?keys as key><option value="${key?html}">${items[key]}</option></#list><#else><#list items as item><option value="${item?html}">${item}</option></#list></#if></#local><#if body?has_content><@label for=id required=attrs["required"]>${body}</@label></#if><select name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","required"]/>>${options}</select></#macro>

<#macro datagrid name columns=[]><table role="grid" style="height:310px;" aria-label="${name?html}"><#if columns?size != 0><thead><tr><#list columns as column><th><#nested column/></th></#list></tr></thead></#if></table></#macro>
<#macro fields name title="" description=""><fieldset name="${name?html}"><@fields_title title, description/><#nested /></fieldset></#macro>
<#macro fields_title title description=""><#if description?length != 0><h6>${title}<span>${description}</span></h6><#elseif title?length != 0><legend>${title}</legend></#if></#macro>
<#macro dialog id attrs...><div id="${id?html}" role="dialog" class="dialog"<@_attributes attrs/>><#nested /></div></#macro>

<#macro dn name maxlength=255 required=true size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro username name maxlength=50 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro password name maxlength=255 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="password" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro url name maxlength=2048 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="url" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro path name maxlength=2048 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro host name maxlength=255 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro port name maxlength=5 required=false size="7" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" <#--type="number" -->name="${name?html}" id="${id}" min="0" max="65535"<@_attributes items=attrs excludes=["id","type","min","max"]/>/></#macro>
<#macro email name maxlength=255 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" <#--type="email" -->name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro number name maxlength=19 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" <#--type="number" -->name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro text name maxlength=4096 required=false size="" attrs...><#local id=attrs["id"]!_nextId()/><#if maxlength?is_number><#local attrs=attrs + {'maxlength': maxlength?c, 'size': (size!)} /><#else><#local attrs=attrs + {'maxlength': maxlength, 'size': (size!)} /></#if><@label for=id required=required><#nested /></@label><input type="text" name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","type"]/>/></#macro>
<#macro memo name attrs...><#local id=attrs["id"]!_nextId()/><@label for=id required=attrs["required"]><#nested /></@label><textarea name="${name?html}" id="${id}"<@_attributes items=attrs excludes=["id","required","value"]/>>${attrs["value"]!""}</textarea></#macro>

<#macro _attributes items excludes=[]><#list items?keys as key><#if !excludes?seq_contains(key) && items[key]?has_content> ${key?replace("([a-z])([A-Z])", "$1-$2", "r")?lower_case}="${items[key]?html}"</#if></#list></#macro>
<#function _nextId><#local id=nextId + 1 /><#assign nextId=id /><#return ":${id}" /></#function>