<#macro restriction name attemptable=false resettable=false>
    <@form.checkbox name="${name}enabled"><#nested /></@>&nbsp;
    <#if attemptable>
        <input type="text" name="${name}" size="3" maxlength="3" />&nbsp;
        <span><@i18n.message "Connections.label.passwordAttempts" />&nbsp;</span><input type="text" name="${name}timeout" size="4" maxlength="4" /><span>&nbsp;<@i18n.message "Connections.unit.timeout" />&nbsp;</span>
        <span><@i18n.message "Connections.label.restoreFor" />&nbsp;<input name="${name}restore" size="3" maxlength="4" /></span><span>&nbsp;<@i18n.message "Connections.unit.timeout" /></span>
    <#elseif resettable>
        <input type="text" name="${name}" size="7" maxlength="7"/>&nbsp;<span><@i18n.message "Connections.unit.size" />,</span>&nbsp;
        <span><@i18n.message "Connections.label.resetEvery" />&nbsp;</span><input name="${name}period" size="4" maxlength="4" /><span>&nbsp;<@i18n.message "Connections.unit.period" /></span>
    <#else>
        <input type="text" name="${name}" size="4" maxlength="4"/>
    </#if>
</#macro>

<fieldset name="connectionsfields" class="panel x-large">
    <fieldset>
        <div><@restriction name="maxconcurcon"><@i18n.message "Connections.label.maxConcurrentConnections" /></@></div>
        <div><@restriction name="maxipcon"><@i18n.message "Connections.label.maxIpConnections" /></@></div>
        <div><@restriction name="maxusercon"><@i18n.message "Connections.label.maxUserConnections" /></@></div>
        <div><@restriction name="maxsessiondloads"><@i18n.message "Connections.label.maxSessionDownloads" /></@></div>
        <div><@restriction name="maxsessionuploads"><@i18n.message "Connections.label.maxSessionUploads" /></@></div>
        <div><@restriction name="maxfiledloadsize"><@i18n.message "Connections.label.maxFileDownloadSize" /></@><@i18n.message "Connections.unit.size" /></div>
        <div><@restriction name="maxfileuploadsize"><@i18n.message "Connections.label.maxFileUploadSize" /></@><@i18n.message "Connections.unit.size" /></div>
        <div><@restriction name="maxdloads" resettable=true><@i18n.message "Connections.label.maxDownloads" /></@></div>
        <div><@restriction name="maxuploads" resettable=true><@i18n.message "Connections.label.maxUploads" /></@></div>
        <div><@restriction name="maxtransfers" resettable=true><@i18n.message "Connections.label.maxTransfers" /></@></div>
        <div><@restriction name="disableaccount" attemptable=true><@i18n.message "Connections.label.disableAccount" /></@></div>
        <div><@restriction name="disableip" attemptable=true><@i18n.message "Connections.label.disableIp" /></@></div>
    </fieldset>

    <div class="viewpane-toolbar">
        <div class="toolbar-management">
            <@form.button name="apply"><@i18n.message "Connections.button.apply" /></@>&nbsp;
            <@form.button name="discard"><@i18n.message "Connections.button.discard" /></@>&nbsp;
        </div>
    </div>
</fieldset>