<#ftl strip_whitespace=true>
<#import "/WEB-INF/tags/html.ftl" as html/>
<#import "/WEB-INF/tags/form.ftl" as form/>
<#import "/WEB-INF/tags/message.ftl" as i18n/>

<@html.page title=i18n.text("Application.title.text")>
    <div id="throbber" class="panel-loading"><@i18n.message key="Application.message.loading" /></div>

    <div id="viewpane" style="visibility: hidden">
        <div data-options="region:'north',border:false" style="height:100px;padding:8px">
            <#include "menu.ftl" />
        </div>

        <div data-options="region:'center',border:false" title="${i18n.text('Domain.title', [domainName, ''], true)}">
            <div id="modules" role="tablist">
                <div role="tab" title="${i18n.text('Statistics.title')}" data-options="iconCls:'icon-m-stats'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Statistics.title')}"><#include "statistics/stats.ftl" /></div>
                        <div role="tab" title="${i18n.text('Sessions.title')}"><#include "statistics/sessions.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Description.title')}" data-options="iconCls:'icon-m-description'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Description.title')}"><#include "description.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Services.title')}" data-options="iconCls:'icon-m-services'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Services.title')}"><#include "services/manage.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.FTP_COMMON')}"><#include "services/ftp.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.SFTP')}"><#include "services/sftp.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.AFTP')}"><#include "services/aftp.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.OFTP')}"><#include "services/oftp.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.TFTP')}"><#include "services/tftp.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.HTTP_COMMON')}"><#include "services/http.ftl" /></div>
                        <div role="tab" title="${i18n.text('Application.protocol.WEBDAV_COMMON')}"><#include "services/webdav.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Logging.title')}" data-options="iconCls:'icon-m-logging'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Logging.titleEvents')}"><#include "logging/logs.ftl" /></div>
                        <div role="tab" title="${i18n.text('Logging.titleSearch')}"><#include "logging/search-criteria.ftl" /></div>
                        <div role="tab" title="${i18n.text('Logging.titleResults')}"><#include "logging/search-results.ftl" /></div>
                        <div role="tab" title="${i18n.text('Logging.titleService')}"><#include "logging/service.ftl" /></div>
                        <div role="tab" title="${i18n.text('Logging.titleSyslog')}"><#include "logging/syslog.ftl" /></div>
                        <div role="tab" title="${i18n.text('Logging.titleSettings')}"><#include "logging/settings.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Reports.title')}" data-options="iconCls:'icon-m-reports'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Reports.title')}"><#include "reports/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('AS2Messages.title')}" data-options="iconCls:'icon-m-as2'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('AS2Messages.title')}"><#include "as2/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Datastore.title')}" data-options="iconCls:'icon-m-datastore'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Datastore.title')}"><#include "datastore/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('TimeAccess.title')}" data-options="iconCls:'icon-m-timeaccess'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('TimeAccess.title')}"><#include "timeaccess/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('BannedFiles.title')}" data-options="iconCls:'icon-m-bannedfiles'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('BannedFiles.title')}"><#include "banned-files/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Compliance.title')}" data-options="iconCls:'icon-m-compliance'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Compliance.title')}"><#include "compliance/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('IpAccess.title')}" data-options="iconCls:'icon-m-ipaccess'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('IpAccess.title')}"><#include "ipaccess/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('DlpRules.title')}" data-options="iconCls:'icon-m-dlp'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('DlpRules.title')}"><#include "dlp/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Connections.title')}" data-options="iconCls:'icon-m-connections'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Connections.title')}"><#include "connections/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Triggers.title')}" data-options="iconCls:'icon-m-triggers'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Triggers.title')}"><#include "triggers/manage.ftl" /></div>
                        <div role="tab" title="${i18n.text('Triggers.title.recent')}"><#include "triggers/recent.ftl" /></div>
                        <div role="tab" title="${i18n.text('Triggers.title.settings')}"><#include "triggers/settings.ftl" /></div>
                        <div role="tab" title="${i18n.text('Triggers.title.actions')}"><#include "triggers/actions.ftl" /></div>
                        <div role="tab" title="${i18n.text('Triggers.title.functions')}"><#include "triggers/functions.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Authentication.title')}" data-options="iconCls:'icon-m-auth'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Authentication.titleService')}"><#include "auth/service.ftl" /></div>
                        <div role="tab" title="${i18n.text('Authentication.titleTwoFactor')}"><#include "auth/two-factor.ftl" /></div>
                        <div role="tab" title="${i18n.text('Authentication.titleSSO')}"><#include "auth/web-sso.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Users.title')}" data-options="iconCls:'icon-m-users'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Users.title')}"><#include "users/manage-users.ftl"></div>
                        <div role="tab" title="${i18n.text('UserTemplates.title')}"><#include "users/manage-templates.ftl"></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Groups.title')}" data-options="iconCls:'icon-m-groups'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Groups.title')}"><#include "groups/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('ReverseProxies.title')}" data-options="iconCls:'icon-m-proxies'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('ReverseProxies.title')}"><#include "proxy/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('DirectoryMonitors.title')}" data-options="iconCls:'icon-m-dirmonitors'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('DirectoryMonitors.title')}"><#include "dirmonitors/manage.ftl" /></div>
                        <div role="tab" title="${i18n.text('DirectoryMonitors.title.settings')}"><#include "dirmonitors/settings.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('DropZones.title')}" data-options="iconCls:'icon-m-dropzones'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('DropZones.title')}"><#include "dropzones/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('UrlBranding.title')}" data-options="iconCls:'icon-m-urlbranding'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('UrlBranding.title')}"><#include "urlbranding/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('TradingPartners.title')}" data-options="iconCls:'icon-m-partners'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('TradingPartners.title')}"><#include "partners/manage.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Contacts.title')}" data-options="iconCls:'icon-m-contacts'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Contacts.title')}"><#include "contancts/manage.ftl" /></div>
                    </div>
                </div>
            </div>
        </div>

        <div data-options="region:'south',border:false" style="height:60px;padding:7px 2em 14px">
            <div class="viewpane-toolbar" style="margin-top:10px;">
                <div class="viewpane-toolbar-selection">
                    <@form.button name="startdomain">${i18n.text('Domain.button.start')}</@>&nbsp;
                    <@form.button name="stopdomain">${i18n.text('Domain.button.stop')}</@>&nbsp;
                    <@form.button name="pausedomain">${i18n.text('Domain.button.pause')}</@>&nbsp;
                    <@form.button name="resumedomain">${i18n.text('Domain.button.resume')}</@>
                </div>
            </div>
        </div>
    </div>
    <#include "users/dialog-ipaccess.ftl" />
    <#include "vfs/dialog-path.ftl" />
    <#include "vfs/dialog-permissions.ftl" />
    <#include "vfs/dialog-pgp-encrypt.ftl" />
    <#include "vfs/dialog-dlp.ftl" />
    <#include "vfs/dialog-dlp-rule.ftl" />

    <#include "domain-js.ftl"/>
</@html.page>
