<#macro search_operator name type="number">
    <#if type == "string">
        <@form.select name="${name}" items={
            '=': i18n.text("Logging.operator.equals"),
            '!=': i18n.text("Logging.operator.notEqual"),
            '#': i18n.text("Logging.operator.contains"),
            '!#': i18n.text("Logging.operator.notContain"),
            '~': i18n.text("Logging.operator.matches"),
            '!~': i18n.text("Logging.operator.notMatch")
        } />
    <#else>
        <@form.select name="${name}" items={'=': '=', '!=': '!=', '>': '>', '>=': '>=', '<': '<', '<=': '<='} />
    </#if>
</#macro>
<#macro criteria_size_unit name>
    <@form.select name="${name}" items={
        '1': i18n.text("Application.size.bytes"),
        '1024': i18n.text("Application.size.kilobyte"),
        '1048576': i18n.text("Application.size.megabyte")
    } />
</#macro>

<fieldset name="searchcriteriafields" class="large">
    <div><@form.dn name="name" size="50" maxlength=150 required=true><@i18n.message key="Logging.label.searchName" /></@></div>
    <div><@form.number name="maxrecords"><@i18n.message key="Logging.label.searchRecords" /></@><span>&nbsp;<@i18n.message key="Logging.label.searchRecordsUnit" /></span></div>

    <fieldset>
        <@form.fields_title title=i18n.text("Logging.legend.searchCriteria")></@>

        <div><@form.checkbox name="daterange" value="Date"><@i18n.message key="Logging.label.dateRange" /></@><input type="date" name="datebegin" />&nbsp;&nbsp;<span><@i18n.message key="Logging.label.dateTo" /></span>&nbsp;&nbsp;<input type="date" name="dateend" /></div>
        <div><@form.checkbox name="byclientip" value="ClientIP"><@i18n.message key="Logging.label.clientIp" /></@><@search_operator name="clientipoperator" type="string"/>&nbsp;<input type="text" name="clientip" size="40" maxlength="150"/></div>
        <div><@form.checkbox name="byclientport" value="ClientPort"><@i18n.message key="Logging.label.clientPort" /></@><@search_operator name="clientportoperator" />&nbsp;<input type="text" name="clientport" size="5" maxlength="5"/></div>
        <div><@form.checkbox name="byserverip" value="ServerIP"><@i18n.message key="Logging.label.serverIp" /></@><@search_operator name="serveripoperator" type="string"/>&nbsp;<input type="text" name="serverip" size="40" maxlength="150"/></div>
        <div><@form.checkbox name="byserverport" value="ServerPort"><@i18n.message key="Logging.label.serverPort" /></@><@search_operator name="serverportoperator" />&nbsp;<input type="text" name="serverport" size="5" maxlength="5"/></div>
        <div><@form.checkbox name="byuser" value="Username"><@i18n.message key="Logging.label.username" /></@><@search_operator name="usernameoperator" type="string"/>&nbsp;<input type="text" name="username" size="40" maxlength="150"/></div>
        <div><@form.checkbox name="byclientrequest" value="ClientRequest"><@i18n.message key="Logging.label.clientRequest" /></@><@search_operator name="clientrequestoperator" type="string"/>&nbsp;<input type="text" name="clientrequest" size="40" maxlength="255"/></div>
        <div><@form.checkbox name="byclientmessage" value="ClientMessage"><@i18n.message key="Logging.label.clientMessage" /></@><@search_operator name="clientmessageoperator" type="string"/>&nbsp;<input type="text" name="clientmessage" size="40" maxlength="255"/></div>
        <div><@form.checkbox name="byserverstatus" value="ServerStatus"><@i18n.message key="Logging.label.serverStatus" /></@><@search_operator name="serverstatusoperator" type="string"/>&nbsp;<input type="text" name="serverstatus" size="40" maxlength="150"/></div>
        <div><@form.checkbox name="byservermessage" value="ServerMessage"><@i18n.message key="Logging.label.serverMessage" /></@><@search_operator name="servermessageoperator" type="string"/>&nbsp;<input type="text" name="servermessage" size="40" maxlength="255"/></div>
        <div><@form.checkbox name="byinbound" value="InboundBytes"><@i18n.message key="Logging.label.inboundBytes" /></@><@search_operator name="inboundoperator"/>&nbsp;<input type="text" name="inbound" size="20" maxlength="20"/>&nbsp;<@criteria_size_unit name="inboundfactor"  /></div>
        <div><@form.checkbox name="byoutbound" value="OutboundBytes"><@i18n.message key="Logging.label.outboundBytes" /></@><@search_operator name="outboundoperator"/>&nbsp;<input type="text" name="outbound" size="20" maxlength="20"/>&nbsp;<@criteria_size_unit name="outboundfactor"  /></div>
    </fieldset>

    <div class="viewpane-toolbar toolbar-management">
        <@form.button name="search"><@i18n.message key="Logging.button.search" /></@>
    </div>
</fieldset>