<#macro trading_partner_add_dialog id protocol>
    <@form.dialog id=id title=i18n.text("TradingPartners.AddDialog.title", protocol)>
        <@form.fields name="tradingpartnerfields" title=i18n.text("TradingPartners.AddDialog.info.short", protocol) description=i18n.text("TradingPartners.AddDialog.info.long")>
            <div style="height:420px;overflow:auto">
                <fieldset>
                    <legend><@i18n.message key="TradingPartners.legend.basic" /></legend>
                    <div><@form.dn name="name" size="50" required=true><@i18n.message key="TradingPartners.label.name" /></@></div>
                    <div><@form.text name="company" maxlength="100" size="40"><@i18n.message key="TradingPartners.label.company" /></@></div>
                    <div><@form.email name="email" size="40"><@i18n.message key="TradingPartners.label.email" /></@></div>
                </fieldset>
                <#nested />
            </div>
            <div class="viewpane-toolbar" style="margin-top:1em">
                <div class="toolbar-management">
                    <@form.button name="test"><@i18n.message "TradingPartners.button.testServer" /></@>
                </div>
            </div>
        </@form.fields>
    </@form.dialog>
</#macro>

<@trading_partner_add_dialog id="d-partner-add-aftp" protocol=i18n.text("Application.protocol.AFTP")><#include "fields-aftp.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-amazons3" protocol=i18n.text("Application.protocol.AMAZON_S3")><#include "fields-amazon-s3.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-as2" protocol=i18n.text("Application.protocol.AS2")><#include "fields-as2.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-ftp" protocol=i18n.text("Application.protocol.FTP")><#include "fields-ftp.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-ftps" protocol=i18n.text("Application.protocol.FTP_COMMON")><#include "fields-ftps.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-imap" protocol=i18n.text("Application.protocol.IMAP")><#include "fields-imap.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-oftp" protocol=i18n.text("Application.protocol.OFTP")><#include "fields-oftp.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-pop3" protocol=i18n.text("Application.protocol.POP3")><#include "fields-pop3.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-rest" protocol=i18n.text("Application.protocol.REST")><#include "fields-rest.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-sftp" protocol=i18n.text("Application.protocol.SFTP")><#include "fields-sftp.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-smtp" protocol=i18n.text("Application.protocol.SMTP")><#include "fields-smtp.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-webdav" protocol=i18n.text("Application.protocol.WEBDAV")><#include "fields-webdav.ftl" /></@>
<@trading_partner_add_dialog id="d-partner-add-tftp" protocol=i18n.text("Application.protocol.TFTP")><#include "fields-tftp.ftl" /></@>