<#macro reverse_proxy_dialog id title>
    <@form.dialog id=id title=title>
        <fieldset name="reverseproxyfields" class="panel">
            <#nested />
            <div class="viewpane-toolbar" style="margin-top:1em">
                <div class="toolbar-management">
                    <@form.button name="test"><@i18n.message "ReverseProxies.button.testServer" /></@>
                </div>
            </div>
        </fieldset>
    </@form.dialog>
</#macro>

<#--FTP Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-ftp" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.FTP"))>
    <#include "fields-name.ftl" />
    <#include "fields-ftp.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-ftp" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.FTP"))>
    <#include "fields-ftp.ftl" />
</@>

<#--SFTP Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-sftp" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.SFTP"))>
    <#include "fields-name.ftl" />
    <#include "fields-sftp.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-sftp" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.SFTP"))>
    <#include "fields-sftp.ftl" />
</@>

<#--AFTP Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-aftp" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.AFTP"))>
    <#include "fields-name.ftl" />
    <#include "fields-aftp.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-aftp" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.AFTP"))>
    <#include "fields-aftp.ftl" />
</@>

<#--OFTP Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-oftp" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.OFTP"))>
    <#include "fields-name.ftl" />
    <#include "fields-oftp.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-oftp" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.OFTP"))>
    <#include "fields-oftp.ftl" />
</@>

<#--TFTP Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-tftp" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.TFTP"))>
    <#include "fields-name.ftl" />
    <#include "fields-tftp.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-tftp" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.TFTP"))>
    <#include "fields-tftp.ftl" />
</@>

<#--WebDAV Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-webdav" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.WEBDAV"))>
    <#include "fields-name.ftl" />
    <#include "fields-webdav.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-webdav" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.WEBDAV"))>
    <#include "fields-webdav.ftl" />
</@>

<#--Amazon S3 Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-amazons3" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.AMAZON_S3"))>
    <#include "fields-name.ftl" />
    <#include "fields-amazon-s3.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-amazons3" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.AMAZON_S3"))>
    <#include "fields-amazon-s3.ftl" />
</@>

<#--REST Reverse Proxy-->
<@reverse_proxy_dialog id="d-proxy-add-rest" title=i18n.text("ReverseProxies.AddDialog.title", i18n.text("Application.protocol.REST"))>
    <#include "fields-name.ftl" />
    <#include "fields-rest.ftl" />
</@>
<@reverse_proxy_dialog id="d-proxy-edit-rest" title=i18n.text("ReverseProxies.EditDialog.title", i18n.text("Application.protocol.REST"))>
    <#include "fields-rest.ftl" />
</@>