<@form.dialog id="d-triggers-add" title=i18n.text("Triggers.AddDialog.title")>
    <@form.fields name="addtriggerparametersfields" title=i18n.text("Triggers.AddDialog.ParametersStep.info.short") description=i18n.text("Triggers.AddDialog.ParametersStep.info.long")>
        <div><@form.dn name="name" size="40" required=true><@i18n.message key="Triggers.label.name" /></@></div>
        <div><@form.select name="eventtype" items={} ariaDescribedby="trigger-event-help"><@i18n.message key="Triggers.label.eventType" /></@>&nbsp;<span id="trigger-event-help" class="help" role="tooltip"></span></div>
        <div><@form.memo name="description"><@i18n.message key="Triggers.label.description" /></@></div>
        <div class="checkbox"><@form.checkbox name="ignoredomainstate"><@i18n.message key="Triggers.label.ignoreDomainState" /></@>&nbsp;
            <@form.select name="domainstate" items={
                'STOPPED': i18n.text("Triggers.ignoredDomainState.STOPPED"),
                'PAUSED': i18n.text("Triggers.ignoredDomainState.PAUSED"),
                'STOPPED_OR_PAUSED': i18n.text("Triggers.ignoredDomainState.STOPPED_OR_PAUSED")
            }/>
        </div>
        <div class="checkbox"><@form.checkbox name="enabled"><@i18n.message key="Triggers.label.triggerEnabled" /></@></div>
        <div class="checkbox"><@form.checkbox name="triggerasync"><@i18n.message key="Triggers.label.triggerAsynchronous" /></@></div>
        <div class="checkbox"><@form.checkbox name="actionsasync"><@i18n.message key="Triggers.label.actionsAsynchronous" /></@></div>
        <div class="checkbox"><@form.checkbox name="fireerror"><@i18n.message key="Triggers.label.fireError" /></@></div>
    </@form.fields>

    <@form.fields name="triggerexpressionfields" title=i18n.text("Triggers.AddDialog.ExpressionStep.info.short") description=i18n.text("Triggers.AddDialog.ExpressionStep.info.long")>
        <div>
            <label for="d-t-expr"><@i18n.message key="Triggers.label.expression" />&nbsp;<span id="trigger-expression-help" class="help" role="tooltip"><@i18n.message key="Triggers.AddDialog.ExpressionStep.help" /></span></label>&nbsp;<br/>
            <textarea id="d-tr-expr" name="expression" aria-describedby="trigger-expression-help" autocomplete="off"></textarea>
        </div>
        <div class="viewpane-toolbar" style="margin-top:1em">
            <div class="toolbar-selection">
                <@form.button name="variables"><@i18n.message key="Triggers.button.variables" /></@>&nbsp;
                <@form.button name="functions"><@i18n.message key="Triggers.button.functions" /></@>&nbsp;
                <@form.button name="constants"><@i18n.message key="Triggers.button.constants" /></@>
            </div>
            <div class="toolbar-management">
                <@form.button name="operators"><@i18n.message key="Triggers.button.operators" /></@>&nbsp;
                <@form.button name="operatorand"><@i18n.message key="Triggers.button.operatorAnd" /></@>&nbsp;
                <@form.button name="operatoror"><@i18n.message key="Triggers.button.operatorOr" /></@>
            </div>
            <div class="toolbar-selection">
                <@form.button name="timeexpression"><@i18n.message key="Triggers.button.timeExpression" /></@>
            </div>
            <div class="toolbar-management">
                <@form.button name="testexpression"><@i18n.message key="Triggers.button.testExpression" /></@>
            </div>
        </div>
    </@form.fields>

    <@form.fields name="triggeractionsfields" title=i18n.text("Triggers.AddDialog.ActionsStep.info.short") description=i18n.text("Triggers.AddDialog.ActionsStep.info.long")>
        <div><@form.datagrid name="triggeractions" columns=["action", "description"]; col><@i18n.message key="Triggers.column.${col}" /></@></div>
        <div class="viewpane-toolbar">
            <div class="toolbar-selection">
                <@form.button name="moveup"><@i18n.message key="Triggers.button.moveUp" /></@>&nbsp;
                <@form.button name="movedown"><@i18n.message key="Triggers.button.moveDown" /></@>
            </div>
            <div class="toolbar-management">
                <@form.button name="add"><@i18n.message key="Triggers.button.add" /></@>&nbsp;
                <@form.button name="edit"><@i18n.message key="Triggers.button.edit" /></@>&nbsp;
                <@form.button name="delete"><@i18n.message key="Triggers.button.delete" /></@>
            </div>
        </div>
    </@form.fields>
</@form.dialog>