<#ftl strip_whitespace=true>
<#import "/WEB-INF/tags/html.ftl" as html/>
<#import "/WEB-INF/tags/form.ftl" as form/>
<#import "/WEB-INF/tags/message.ftl" as i18n/>

<@html.page title=i18n.text("Application.title.text")>
    <div id="viewpane" style="margin:12em auto;width: 500px">
        <div id="signin-box" title="${i18n.text('Login.title')}">
            <form action="/settings/login" method="post" accept-charset="utf-8" novalidate>
                <fieldset name="userloginfields">
                    <#if page?? && page.destUri??><input type="hidden" name="ref" value="${page.destUri?html}"/></#if>
                    <dl class="group">
                        <dt><label for="username"><@i18n.message key="Login.label.username" /><em>*</em></label></dt>
                        <dd><@form.username id="username" name="login" size="30" autofocus="autofocus" autocomplete="off" required=true /></dd>
                        <dt><label for="password"><@i18n.message key="Login.label.password" /></label></dt>
                        <dd><@form.password id="password" name="pwd" size="30" autocomplete="off" /><#if authentication.error><div class="erm">${authentication.reason?html}</div></#if></dd>
                        <dt>&nbsp;</dt>
                        <dd class="ar"><@form.button name="signin"><@i18n.message key="Login.button.submit"/></@></dd>
                    </dl>
                </fieldset>
            </form>
        </div>
    </div>

    <script type="text/javascript">
        if (top.location != self.location) { top.location = self.location.href; }
        function setCookie(name, value) { document.cookie = name + "=" + value + ";path=/"; }

        $(document).ready(function() {
            var resources = new jscape.Resources({
                DIALOG_BUTTON_CLOSE: '<@i18n.message key="Dialog.button.close" />',
                DIALOG_BUTTON_DETAILS: '<@i18n.message key="Dialog.button.details" />',
                DIALOG_TITLE: '<@i18n.message key="Dialog.title.error" />',
                INTERNAL_ERROR: '<@i18n.message key="Manager.Error.code.INTERNAL_ERROR" />',
                BAD_CREDENTIALS: '<@i18n.message key="Manager.Error.code.BAD_CREDENTIALS" />',
                NOT_AUTHENTICATED: '<@i18n.message key="Manager.Error.code.NOT_AUTHENTICATED" />',
                SESSION_EXPIRED: '<@i18n.message key="Manager.Error.code.SESSION_EXPIRED" />',
                DOMAIN_NOT_FOUND: '<@i18n.message key="Manager.Error.code.DOMAIN_NOT_FOUND" />',
                NO_PERMISSIONS: '<@i18n.message key="Manager.Error.code.NO_PERMISSIONS" />'
            });

            function onLoginSubmit() { if (f.form("validate")) { setCookie("MFT_CS", $.now()); f.submit(); }};
            var b = $("#signin-box")
                    .panel({border: true});
            var f = b.find("form:first");
            var u = b.find("input[name=login]")
                    .validatebox({required: true, missingMessage: '${i18n.text("Login.Error.emptyUsername")}', invalidMessage: '${i18n.text("Login.Error.emptyUsername")}'})
                    .keydown(function(e) { if (e.keyCode == 13) { p.focus(); }});
            var p = b.find("input[name=pwd]")
                    .keydown(function(e) { if (e.keyCode == 13) { onLoginSubmit(); }});
            var s = b.find("a[role=button][name=signin]")
                    .linkbutton({onClick: onLoginSubmit});
            $("#viewpane").css("visibility", "visible");
            u.focus();
        });
    </script>
</@html.page>