<div id="add-domain-wizard" title="${i18n.text('AddDomainDialog.title')}" class="dialog">
    <#--Step 1 - Domain Name-->
    <fieldset name="domainparametersfields" class="hidden">
        <@form.fields_title title=i18n.text("AddDomainDialog.title.domainName") description=i18n.text("AddDomainDialog.info.domainName")></@>
        <div><@form.dn name="name" size="40" required=true><@i18n.message key="AddDomainDialog.label.domainName" /></@></div>
        <div><@form.memo name="description"><@i18n.message key="AddDomainDialog.label.domainDescription" /></@></div>
    </fieldset>

    <#--Step 2 - Domain Service-->
    <fieldset name="domainservicefields" class="hidden" style="height:297px">
        <@form.fields_title title=i18n.text("AddDomainDialog.title.domainService") description=i18n.text("AddDomainDialog.info.domainService")></@>
        <div><@form.select name="protocol" items={
            'AFTP': i18n.text("Application.protocol.AFTP"),
            'AS2': i18n.text("Application.protocol.AS2"),
            'FTP': i18n.text("Application.protocol.FTP_COMMON"),
            'HTTP': i18n.text("Application.protocol.HTTP_COMMON"),
            'OFTP': i18n.text("Application.protocol.OFTP"),
            'SFTP': i18n.text("Application.protocol.SFTP"),
            'WEBDAV': i18n.text("Application.protocol.WEBDAV_COMMON")
        }><@i18n.message key="Services.label.protocol" /></@>
        </div>
        <fieldset name="ftpservicefields" class="hidden">
            <div><@form.select name="host" items={} required=true><@i18n.message key="Services.label.host" /></@></div>
            <div><@form.port name="port"><@i18n.message key="Services.label.port" /></@></div>
            <div><@form.select name="type" items={
                'regular': i18n.text("Application.protocol.FTP.regular"),
                'explicit SSL': i18n.text("Application.protocol.FTP.explicitSsl"),
                'forced explicit SSL': i18n.text("Application.protocol.FTP.forcedExplicitSsl"),
                'implicit SSL': i18n.text("Application.protocol.FTP.implicitSsl")
            }><@i18n.message key="Services.label.type" /></@></div>
            <div><@form.select name="privatekey" items={}><@i18n.message key="Services.label.privateKey" /></@></div>
        </fieldset>
        <fieldset name="sftpservicefields" class="hidden">
            <div><@form.select name="host" items={} required=true><@i18n.message key="Services.label.host" /></@></div>
            <div><@form.port name="port"><@i18n.message key="Services.label.port" /></@></div>
            <div><@form.select name="privatekey" items={}><@i18n.message key="Services.label.privateKey" /></@></div>
            <div><@form.select name="auth" items={
                'password': i18n.text("Services.auth.password"),
                'publickey': i18n.text("Services.auth.publicKey"),
                'password OR publickey': i18n.text("Services.auth.passwordOrPublicKey"),
                'password AND publickey': i18n.text("Services.auth.passwordAndPublicKey")
            }><@i18n.message key="Services.label.authentication" /></@></div>
        </fieldset>
        <fieldset name="aftpservicefields" class="hidden">
            <div><@form.select name="host" items={} required=true><@i18n.message key="Services.label.host" /></@></div>
            <div><@form.port name="port"><@i18n.message key="Services.label.port" /></@></div>
            <div><@form.select name="privatekey" items={}><@i18n.message key="Services.label.privateKey" /></@></div>
            <div class="checkbox"><@form.checkbox name="requiresecure"><@i18n.message key="Services.label.securedConnectionRequired" /></@></div>
        </fieldset>
        <fieldset name="oftpservicefields" class="hidden">
            <div><@form.select name="host" items={} required=true><@i18n.message key="Services.label.host" /></@></div>
            <div><@form.port name="port"><@i18n.message key="Services.label.port" /></@></div>
            <div><@form.dn name="idcode" size="40" maxlength="500" required=true><@i18n.message key="Services.label.identificationCode" /></@></div>
            <div><@form.select name="privatekey" items={}><@i18n.message key="Services.label.privateKey" /></@></div>
            <div class="checkbox"><@form.checkbox name="usessl"><@i18n.message key="Services.label.userSsl" /></@></div>
            <div class="checkbox"><@form.checkbox name="fileencryption"><@i18n.message key="Services.label.fileEncryptionRequired" /></@></div>
            <div class="checkbox"><@form.checkbox name="filesignature"><@i18n.message key="Services.label.fileSignatureRequired" /></@></div>
        </fieldset>
        <fieldset name="httpservicefields" class="hidden">
            <div class="checkbox"><@form.checkbox name="plain"><@i18n.message key="Services.label.http" /></@></div>
            <div class="checkbox"><@form.checkbox name="secure"><@i18n.message key="Services.label.https" /></@></div>
        </fieldset>
        <fieldset name="webdavservicefields" class="hidden">
            <div class="checkbox"><@form.checkbox name="plain"><@i18n.message key="Services.label.http" /></@></div>
            <div class="checkbox"><@form.checkbox name="secure"><@i18n.message key="Services.label.https" /></@></div>
        </fieldset>
        <fieldset name="as2servicefields" class="hidden">
            <div class="checkbox"><@form.checkbox name="plain"><@i18n.message key="Services.label.http" /></@></div>
            <div class="checkbox"><@form.checkbox name="secure"><@i18n.message key="Services.label.https" /></@></div>
        </fieldset>
    </fieldset>

    <#--Step 3 - Datastore Service-->
    <fieldset name="datastoreservicefields" class="hidden">
        <@form.fields_title title=i18n.text("AddDomainDialog.title.datastoreService") description=i18n.text("AddDomainDialog.info.datastoreService")></@>
        <div><@form.select name="type" items={
                'FILE': i18n.text("Datastore.type.file"),
                'FILE_RECORD': i18n.text("Datastore.type.fileRecord"),
                'DB': i18n.text("Datastore.type.database")
            }><@i18n.message key="Datastore.label.type" /></@form.select>
        </div>
        <fieldset name="filerecorddatastorefields" class="hidden">
            <div><@form.path name="directory" size="50" required=true><@i18n.message key="Datastore.label.directory" /></@>&nbsp;<@form.button name="browse"><@i18n.message key="Datastore.button.browse" /></@></div>
            <div class="viewpane-toolbar toolbar-selection">
                <@form.button name="addvariable"><@i18n.message key="Datastore.button.addVariable" /></@>
            </div>
        </fieldset>
        <fieldset name="filedatastorefields" class="hidden">
            <div><@form.path name="directory" size="50" required=true><@i18n.message key="Datastore.label.directory" /></@>&nbsp;<@form.button name="browse"><@i18n.message key="Datastore.button.browse" /></@></div>
            <div class="viewpane-toolbar toolbar-selection">
                <@form.button name="addvariable"><@i18n.message key="Datastore.button.addVariable" /></@>
            </div>
        </fieldset>
        <fieldset name="dbdatastorefields" class="hidden">
            <div><@form.url name="dburl" size="50" required=true><@i18n.message key="Datastore.label.dbUrl" /></@></div>
            <div><@form.username name="username" size="40" required=true><@i18n.message key="Datastore.label.username" /></@></div>
            <div><@form.password name="password" size="40"><@i18n.message key="Datastore.label.password" /></@></div>
            <div><@form.number name="poolsize" size="8" maxlength="3"><@i18n.message key="Datastore.label.poolSize" /></@>&nbsp;<span><@i18n.message key="Datastore.label.poolSizeUnit" /></span></div>
            <div><@form.number name="pooltimeout" size="8" maxlength="3"><@i18n.message key="Datastore.label.poolTimeout" /></@>&nbsp;<span><@i18n.message key="Datastore.label.poolTimeoutUnit" /></span></div>
            <div class="viewpane-toolbar toolbar-management">
                <@form.button name="testdb"><@i18n.message key="Datastore.button.test" /></@>
            </div>
        </fieldset>
    </fieldset>

    <#--Step 4 - Log Service -->
    <fieldset name="logservicefields" class="hidden">
        <@form.fields_title title=i18n.text("AddDomainDialog.title.logService") description=i18n.text("AddDomainDialog.info.logService")></@>
        <div><@form.select name="type" items={
                'FILE': i18n.text("Logging.type.file"),
                'DB': i18n.text("Logging.type.database")
            }><@i18n.message key="Logging.label.type" /></@form.select>
        </div>
        <fieldset name="filelogservicefields" class="hidden">
            <div><@form.path name="directory" size="50" required=true><@i18n.message key="Logging.label.directory" /></@>&nbsp;<@form.button name="browsedir"><@i18n.message key="Logging.button.browse" /></@></div>
            <dl class="group">
                <dt><@i18n.message key="Logging.label.fileStrategy" /></dt>
                <dd class="radio"><@form.radio name="strategy" value="Daily" checked="checked"><@i18n.message key="Logging.fileStrategy.daily" /></@></dd>
                <dd class="radio"><@form.radio name="strategy" value="Weekly"><@i18n.message key="Logging.fileStrategy.weekly" /></@></dd>
                <dd class="radio"><@form.radio name="strategy" value="Monthly"><@i18n.message key="Logging.fileStrategy.monthly" /></@></dd>
                <dd class="radio"><@form.radio name="strategy" value="FileSize"><@i18n.message key="Logging.fileStrategy.fileSize" />&nbsp;<input type="text" name="filesize" size="8" maxlength="3" /><span>&nbsp;<@i18n.message key="Logging.fileStrategy.fileSizeUnit" /></span></@></dd>
            </dl>
            <div class="viewpane-toolbar toolbar-selection">
                <@form.button name="addvar"><@i18n.message key="Logging.button.addVariable" /></@>
            </div>
        </fieldset>
        <fieldset name="dblogservicefields" class="hidden">
            <div><@form.url name="dburl" size="50" required=true><@i18n.message key="Logging.label.dbUrl" /></@></div>
            <div><@form.username name="username" size="40" required=true><@i18n.message key="Logging.label.dbUser" /></@></div>
            <div><@form.password name="password" size="40"><@i18n.message key="Logging.label.dbPassword" /></@></div>
            <div><@form.number name="poolsize" size="8" maxlength="3"><@i18n.message key="Logging.label.poolSize" /></@>&nbsp;<span><@i18n.message key="Logging.label.poolSizeUnit" /></span></div>
            <div><@form.number name="idlettl" size="8" maxlength="3"><@i18n.message key="Logging.label.dbIdleTtl" /></@>&nbsp;<span><@i18n.message key="Logging.label.dbIdleTtlUnit" /></span></div>
            <div class="viewpane-toolbar toolbar-management">
                <@form.button name="testdb"><@i18n.message key="Logging.button.testParameters" /></@>
            </div>
        </fieldset>
    </fieldset>
</div>