<#ftl strip_whitespace=true>
<#import "/WEB-INF/tags/html.ftl" as html/>
<#import "/WEB-INF/tags/form.ftl" as form/>
<#import "/WEB-INF/tags/message.ftl" as i18n/>

<@html.page title=i18n.text("Application.title.text")>
    <div id="throbber" class="panel-loading"><@i18n.message key="Application.message.loading" /></div>

    <div id="viewpane" style="visibility: hidden">
        <div data-options="region:'north',border:false" style="height:100px;padding:8px">
            <#include "menu.ftl" />
        </div>

        <div data-options="region:'center',border:false">
            <div id="server-settings" role="tablist">
                <div role="tab" title="${i18n.text('ManagerService.title')}" data-options="iconCls:'icon-s-manager'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('ManagerService.title')}"><#include "manager/service.ftl" /></div>
                        <div role="tab" title="${i18n.text('ManagerAccess.title')}"><#include "manager/access.ftl" /></div>
                        <div role="tab" title="${i18n.text('Administrators.title')}"><#include "manager/administrators.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('DomainsAutoStart.title')}" data-options="iconCls:'icon-s-autostart'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('DomainsAutoStart.title')}"><#include "domainstartup/domain-startup.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('WebPanel.title')}" data-options="iconCls:'icon-s-web'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('WebConfiguration.title')}"><#include "web/config.ftl" /></div>
                        <div role="tab" title="${i18n.text('WebRestConfiguration.title')}"><#include "web/rest.ftl" /></div>
                        <div role="tab" title="${i18n.text('AS2Configuration.title')}"><#include "web/as2.ftl" /></div>
                        <div role="tab" title="${i18n.text('WebMisc.title')}"><#include "web/misc.ftl" /></div>
                        <div role="tab" title="${i18n.text('WebResources.title')}"><#include "web/resources.ftl" /></div>
                        <div role="tab" title="${i18n.text('WebDocumentViewer.title')}"><#include "web/doc-viewer.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('DBDrivers.title')}" data-options="iconCls:'icon-s-dbdrivers'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('DBDrivers.title')}"><#include "dbdrivers/jdbc-config.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Email.title')}" data-options="iconCls:'icon-s-email'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Email.title')}"><#include "email/config.ftl" /></div>
                        <div role="tab" title="${i18n.text('EmailMisc.title')}"><#include "email/misc.ftl" /></div>
                        <div role="tab" title="${i18n.text('AdHocTransfer.title')}"><#include "email/ad-hoc.ftl" /></div>
                        <div role="tab" title="${i18n.text('EmailResources.title')}"><#include "email/resources.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('Failover.title')}" data-options="iconCls:'icon-s-failover'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('Failover.title')}"><#include "failover/failover-config.ftl" /></div>
                        <div role="tab" title="${i18n.text('IPSubstitution.title')}"><#include "failover/ip-substitution.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('SearchService.title')}" data-options="iconCls:'icon-s-search'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('SearchService.title')}"><#include "searching/config.ftl" /></div>
                    </div>
                </div>
                <div role="tab" title="${i18n.text('JmxService.title')}" data-options="iconCls:'icon-s-jmx'">
                    <div role="tablist">
                        <div role="tab" title="${i18n.text('JmxService.title')}"><#include "jmx/config.ftl" /></div>
                    </div>
                </div>
            </div>
        </div>

        <div data-options="region:'south',border:false" style="height:60px;padding:7px 2em 14px">
            <div class="viewpane-toolbar" style="margin-top:10px;">
                <div class="toolbar-management">
                    <@form.button name="savesettings"><@i18n.message key="Dialog.button.save" /></@>&nbsp;
                    <@form.button name="cancelsettings"><@i18n.message key="Dialog.button.cancel" /></@>
                </div>
            </div>
        </div>
    </div>
    <#include "web/dialog-ciphers.ftl" />
    <#include "settings-js.ftl">
</@html.page>