jscape.domain = jscape.domain || {};

/** @class */
jscape.TradingPartner = Class.extend(
    /** @lends {jscape.TradingPartner.prototype} */
{
    /** @constructor */
    initialize: function(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z, aa, ab, ac, ad) {
        this.name = a || "";
        this.protocol = b || "";
        this.company = c || null;
        this.email = d || "";
        this.url = e || "";
        this.host = f || "";
        this.port = parseInt(g) || 0;
        this.timeout = parseInt(h) || 0;
        this.connectionType = i || null;
        this.username = j !== undefined ? j : "";
        this.password = k !== undefined ? k : null;
        this.domain = l !== undefined ? l : null;
        this.keyProvider = m || null;
        this.hostKeyProvider = n || null;
        this.ftpPostLoginCommand = o || "";
        this.as2CompressionRequired = p !== undefined ? !!p : false;
        this.as2Sender = q || "";
        this.as2Recipient = r || "";
        this.as2ReceiptType = s || "";
        this.as2ReceiptHttpsRequired = t !== undefined ? !!t : false;
        this.as2ReceiptSignatureRequired = u !== undefined ? !!u : false;
        this.as2ReceiptAwaitingTimeout = parseInt(v) || 0;
        this.encryptionKeyProvider = w || null;
        this.encryptionAlgorithm = x || null;
        this.signingKeyProvider = y || null;
        this.signatureAlgorithm = z || null;
        this.sftpStartSubsystemReplyRequired = aa !== undefined ? !!aa : false;
        this.encryptionRequired = ab !== undefined ? !!ab : false;
        this.oftpDestination = ac || "";
        this.oftpCipherSuite = ad || null;
    }
});
jscape.TradingPartner.fromJSON = function(data) {
    function keyProviderOf(provider) {
        return provider ? (provider.keyAlias ? jscape.ServerKeyProvider.fromJSON(provider) : (provider.file ? jscape.FileKeyProvider.fromJSON(provider) : null)) : null;
    }
    return $.extend(new jscape.TradingPartner(), data, {
        keyProvider: keyProviderOf(data.keyProvider),
        hostKeyProvider: keyProviderOf(data.hostKeyProvider),
        encryptionKeyProvider: keyProviderOf(data.encryptionKeyProvider),
        signingKeyProvider: keyProviderOf(data.signingKeyProvider),
        sftpStartSubsystemReplyRequired: !!data.sftpStartSubsystemReplyRequired
    });
};
jscape.TradingPartner.aftp = function(name, company, email, host, port, timeout, username, password, keyProvider, hostKeyProvider) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.AFTP, company, email, undefined, host, port, timeout, undefined, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider
    });
};
jscape.TradingPartner.amazonS3 = function(name, company, email,timeout, username, password, encryptionRequired) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.AMAZON_S3, company, email, undefined, undefined, undefined, timeout, undefined, username, password), {
        encryptionRequired: encryptionRequired
    });
};
jscape.TradingPartner.as2 = function(name, company, email, url, timeout, username, password, keyProvider, hostKeyProvider, compressionRequired, sender, recipient, receiptType, receiptUseSsl, receiptSignatureRequired, receiptAwaitingTimeout, encryptionKeyProvider, encryptionAlgorithm, signingKeyProvider, signatureAlgorithm) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.AS2, company, email, url, undefined, undefined, timeout, undefined, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider, as2CompressionRequired: compressionRequired, as2Sender: sender, as2Recipient: recipient,
        as2ReceiptType: receiptType, as2ReceiptHttpsRequired: !!receiptUseSsl, as2ReceiptSignatureRequired: !!receiptSignatureRequired, as2ReceiptAwaitingTimeout: parseInt(receiptAwaitingTimeout),
        encryptionKeyProvider: encryptionKeyProvider, encryptionAlgorithm: encryptionAlgorithm, signingKeyProvider: signingKeyProvider, signatureAlgorithm: signatureAlgorithm
    });
};
jscape.TradingPartner.sftp = function(name, company, email, host, port, timeout, username, password, keyProvider, hostKeyProvider, sftpStartSubsystemReplyRequired) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.SFTP, company, email, undefined, host, port, timeout, undefined, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider, sftpStartSubsystemReplyRequired: !!sftpStartSubsystemReplyRequired
    });
};
jscape.TradingPartner.ftp = function(name, company, email, host, port, timeout, username, password, ftpPostLoginCommand) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.FTP, company, email, undefined, host, port, timeout, undefined, username, password), {
        ftpPostLoginCommand: ftpPostLoginCommand
    });
};
jscape.TradingPartner.ftpsImplicit = function(name, company, email, host, port, timeout, username, password, keyProvider, hostKeyProvider, ftpPostLoginCommand) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.FTPS_IMPLICIT, company, email, undefined, host, port, timeout, undefined, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider, ftpPostLoginCommand: ftpPostLoginCommand
    });
};
jscape.TradingPartner.ftpsExplicit = function(name, company, email, host, port, timeout, username, password, keyProvider, hostKeyProvider, ftpPostLoginCommand) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.FTPS_EXPLICIT, company, email, undefined, host, port, timeout, undefined, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider, ftpPostLoginCommand: ftpPostLoginCommand
    });
};
jscape.TradingPartner.webdav = function(name, company, email, url, timeout, username, password, domain, keyProvider, hostKeyProvider) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.WEBDAV, company, email, url, undefined, undefined, timeout, undefined, username, password), {
        domain: domain, keyProvider: keyProvider, hostKeyProvider: hostKeyProvider
    });
};
jscape.TradingPartner.oftp = function(name, company, email, host, port, timeout, username, password, keyProvider, hostKeyProvider, destination, encryptionKeyProvider, signingKeyProvider, encryptionRequired, cipherSuite) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.OFTP, company, email, undefined, host, port, timeout, undefined, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider, encryptionKeyProvider: encryptionKeyProvider, signingKeyProvider: signingKeyProvider,
        encryptionRequired: !!encryptionRequired, oftpDestination: destination, oftpCipherSuite: cipherSuite
    });
};
jscape.TradingPartner.rest = function(name, company, email, host, port, timeout, username, password, domain, keyProvider, hostKeyProvider, encryptionRequired) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.REST, company, email, undefined, host, port, timeout, undefined, username, password), {
        domain: domain, keyProvider: keyProvider, hostKeyProvider: hostKeyProvider, encryptionRequired: !!encryptionRequired
    });
};
jscape.TradingPartner.tftp = function(name, company, email, host, port, timeout) {
    return new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.TFTP, company, email, undefined, host, port, timeout);
};
jscape.TradingPartner.imap = function(name, company, email, host, port, timeout, connectionType, username, password, keyProvider, hostKeyProvider) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.IMAP, company, email, undefined, host, port, timeout, connectionType, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider
    });
};
jscape.TradingPartner.pop3 = function(name, company, email, host, port, timeout, connectionType, username, password, keyProvider, hostKeyProvider) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.POP3, company, email, undefined, host, port, timeout, connectionType, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider
    });
};
jscape.TradingPartner.smtp = function(name, company, email, host, port, timeout, connectionType, username, password, keyProvider, hostKeyProvider) {
    return $.extend(new jscape.TradingPartner(name, jscape.TradingPartner.Protocol.SMTP, company, email, undefined, host, port, timeout, connectionType, username, password), {
        keyProvider: keyProvider, hostKeyProvider: hostKeyProvider
    });
};
jscape.TradingPartner.Protocol = {AFTP: "AFTP", AMAZON_S3: "AmazonS3", AS2: "AS2", FTP: "FTP", FTPS_IMPLICIT: "Implicit FTPS", FTPS_EXPLICIT: "Explicit FTPS", IMAP: "IMAP", OFTP: "OFTP", POP3: "POP3", REST: "REST", SFTP: "SFTP", SMTP: "SMTP", TFTP: "TFTP", WEBDAV: "WebDAV", WEBDAV_SSL: "WebDAV SSL"};

/** @class */
jscape.domain.TradingPartnersModule = jscape.domain.DomainModule.extend(
    /** @lends {jscape.domain.TradingPartnersModule.prototype} */
{
    onCreate: function() {
        this._super.apply(this, arguments);

        this.controller = new jscape.domain.TradingPartnersController(this.resources);
    },

    onStart: function () {
        this.controller.start(this.managementService, this.domainName);
    },

    onResume: function () {
        this.controller._loadData();
    }
});

/** @class */
jscape.domain.TradingPartnersController = Class.extend(
    /** @lends {jscape.domain.TradingPartnersController.prototype} */
{
    partners: null,

    /** @constructor */
    initialize: function(resources) {
        this.partners = [];
        this.view = new jscape.domain.TradingPartnersView(resources);
        this.addController = new jscape.domain.AddTradingPartnerController(resources);
        this.copyController = new jscape.domain.CopyTradingPartnerController(resources);
        this.editController = new jscape.domain.EditTradingPartnerController(resources);
        this.deleteController = new jscape.domain.DeleteTradingPartnerController(resources);
        this.testController = new jscape.domain.TestTradingPartnerController(resources);

        this._initValidators(resources);
    },

    start: function(managementService, domainName) {
        this.managementService = managementService;
        this.domainName = domainName;
        this.view.show(this);
    },

    onAddPartner: function() {
        this.addController.start(this, this.managementService, this.domainName)
                .done($.proxy(this._partnerAdded, this));
    },

    onCopyPartner: function(partner) {
        this.copyController.start(this.managementService, this.domainName, partner.name)
                .done($.proxy(this._partnerAdded, this));
    },

    onEditPartner: function (partner) {
        var index = $.inArray(partner, this.partners);
        if (index != -1) {
            this.editController.start(this, this.managementService, this.domainName, partner)
                    .done($.proxy(this._partnerEdited, this, index));
        }
    },

    onDeletePartner: function(partners) {
        this.deleteController.start(this.managementService, this.domainName, partners)
                .done($.proxy(this._partnerDeleted, this, partners));
    },

    onTestPartner: function(partner) {
        this.testController.start(this.managementService, this.domainName, partner);
    },

    _partnerAdded: function(item) {
        this.partners.push(item);
        this.view.setTradingPartners(this.partners);
        this.view.selectItem(item);
    },

    _partnerEdited: function (index, item) {
        this.partners[index] = item;
        this.view.setTradingPartners(this.partners);
        this.view.selectItem(item);
    },

    _partnerDeleted: function (items) {
        var index = -1;
        while (items.length) {
            index = $.inArray(items.pop(), this.partners);
            this.partners.splice(index, 1);
        }
        this.view.setTradingPartners(this.partners);

        if (this.partners.length) {
            index = Math.max(0, Math.min(index, this.partners.length - 1));
            this.view.selectItem(this.partners[index]);
        }
    },

    _loadData: function() {
        this.managementService.getTradingPartners(this.domainName)
                .done($.proxy(function(partners) {
                    this.partners = partners || [];
                    this.view.setTradingPartners(this.partners);
                }, this));
    },

    _initValidators: function (resources) {
        var v = new jscape.Validator();
        v.nonEmptyRule("partner_name_nonempty", resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME"));
        v.nonEmptyRule("partner_host_nonempty", resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST"));
        v.rule("partner_unique", $.proxy(this._partnerNotExists, this), resources.getString("TRADING_PARTNERS_ERROR_ALREADY_EXIST"));
        v.rule("partner_url", $.proxy(this._validUrl, this), resources.getString("TRADING_PARTNERS_ERROR_BAD_URL"));
        v.rule("partner_sender", $.proxy(this._validAs2Name, this), resources.getString("TRADING_PARTNERS_ERROR_BAD_SENDER"));
        v.rule("partner_recipient", $.proxy(this._validAs2Name, this), resources.getString("TRADING_PARTNERS_ERROR_BAD_RECIPIENT"));
    },

    _partnerNotExists: function(value) {
        value = (value || "").toUpperCase();
        return $.grep(this.partners, function(partner) { return partner.name.toUpperCase() === value; }).length == 0;
    },

    _validUrl: function(value) {
        return /http(s)?:\/\/.+/i.test(value);
    },

    _validAs2Name: function(value) {
        var atomicName = /^[\x21\x23-\x5B\x5D-\x7E]{1,128}$/;
        var quotedName = /^"([\x20\x21\x23-\x5B\x5D-\x7E]){1,128}"$/;
        return atomicName.test(value) || quotedName.test(value);
    }
});

/** @class */
jscape.domain.TradingPartnersView = Class.extend(
    /** @lends {jscape.domain.TradingPartnersView.prototype} */
{
    selection: null,

    /** @constructor */
    initialize: function(resources) {
        this.selection = [];
        this.resources = resources;

        this.fieldset = $("fieldset[name=tradingpartnersfields]");

        this.data = $("table[role=grid][aria-label=tradingpartners]", this.fieldset);
        this.data.datagrid({
            fitColumns: true,
            singleSelect: true,
            pagination: true,
            search: true,
            remoteSort: false,
            sortName: "name",
            columns: [[
                {field: "name", title: $("thead th:nth-child(1)", this.data).text(), width: 200, sortable: true},
                {field: "company", title: $("thead th:nth-child(2)", this.data).text(), width: 100, sortable: true, resizable: true, sorter: function(a, b) { return a == b ? 0 : a == null || a < b ? -1 : 1; }},
                {field: "protocol", title: $("thead th:nth-child(3)", this.data).text(), width: 100, sortable: true, formatter: $.proxy(this._formatProtocol, this)},
                {field: "server", title: $("thead th:nth-child(4)", this.data).text(), width: 200, sortable: false, formatter: $.proxy(function(_, row) { return this._formatServer(row); }, this)}
            ]],
            onDblClickRow: $.proxy(this._onClick$EditButton, this),
            onSelect: $.proxy(this._adjustRowSelection, this),
            onUnselect: $.proxy(this._adjustRowSelection, this),
            onLoadSuccess: $.proxy(this._adjustRowSelection, this)
        });

        this.addButton = $("a[role=button][name=add]", this.fieldset);
        this.addButton.linkbutton({onClick: $.proxy(this._onClick$AddButton, this)});

        this.editButton = $("a[role=button][name=edit]", this.fieldset);
        this.editButton.linkbutton({disabled: true, onClick: $.proxy(this._onClick$EditButton, this)});

        this.copyButton = $("a[role=button][name=copy]", this.fieldset);
        this.copyButton.linkbutton({disabled: true, onClick: $.proxy(this._onClick$CopyButton, this)});

        this.deleteButton = $("a[role=button][name=delete]", this.fieldset);
        this.deleteButton.linkbutton({disabled: true, onClick: $.proxy(this._onClick$DeleteButton, this)});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({disabled: true, onClick: $.proxy(this._onClick$TestButton, this)});
    },

    show: function(listener) {
        this.listener = listener || jscape.domain.TradingPartnersView.LISTENER;
        this._adjustButtonsState();
    },

    setTradingPartners: function (values) {
        this.data.datagrid("loading");
        this.data.datagrid("loadData", values);
        this.data.datagrid("loaded");
    },

    selectItem: function (value) {
        this.data.datagrid("selectRow", this.data.datagrid("getRowIndex", value));
    },

    _formatProtocol: function (value) {
        return this.resources.getString("APPLICATION_PROTOCOL_" + (value + "").toUpperCase().replace(" ", "_"));
    },

    _formatServer: function (partner) {
        return (partner.url && partner.url.trim().length
                ? partner.url
                : partner.host ? partner.host + (partner.port ? ":" + partner.port: "") : "")
                .escapeXml();
    },

    _onClick$AddButton: function() {
        this.listener.onAddPartner(this);
    },

    _onClick$EditButton: function() {
        this.listener.onEditPartner(this.selection[0]);
    },

    _onClick$CopyButton: function() {
        this.listener.onCopyPartner(this.selection[0]);
    },

    _onClick$DeleteButton: function() {
        this.listener.onDeletePartner(this.selection);
    },

    _onClick$TestButton: function() {
        this.listener.onTestPartner(this.selection[0]);
    },

    _adjustRowSelection: function () {
        this.selection = this.data.datagrid("getSelections");
        this._adjustButtonsState();
    },

    _adjustButtonsState: function() {
        var singleSelection = this.selection.length == 1;
        this.editButton.linkbutton(singleSelection ? "enable" : "disable");
        this.copyButton.linkbutton(singleSelection ? "enable" : "disable");
        this.deleteButton.linkbutton(this.selection.length != 0 ? "enable" : "disable");
        this.testButton.linkbutton(singleSelection ? "enable" : "disable");
    }
});
jscape.domain.TradingPartnersView.LISTENER = {
    onAddPartner: $.noop,
    onEditPartner: $.noop,
    onCopyPartner: $.noop,
    onDeletePartner: $.noop,
    onTestPartner: $.noop
};

/** @class */
jscape.domain.AddTradingPartnerController = Class.extend(
    /** @lends {jscape.domain.AddTradingPartnerController.prototype} */
{
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
        this.controllerMap = {};
        this.controllerMap[jscape.TradingPartner.Protocol.AFTP] = jscape.domain.AddAftpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.AS2] = jscape.domain.AddAs2TradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.AMAZON_S3] = jscape.domain.AddAmazonS3TradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.FTP] = jscape.domain.AddFtpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.FTPS_IMPLICIT] = jscape.domain.AddFtpsImplicitTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.FTPS_EXPLICIT] = jscape.domain.AddFtpsExplicitTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.IMAP] = jscape.domain.AddImapTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.OFTP] = jscape.domain.AddOftpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.POP3] = jscape.domain.AddPop3TradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.REST] = jscape.domain.AddRestTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.SFTP] = jscape.domain.AddSftpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.SMTP] = jscape.domain.AddSmtpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.WEBDAV] = jscape.domain.AddWebDavTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.TFTP] = jscape.domain.AddTftpTradingPartnerController;
    },

    start: function(listener, managementService, domainName) {
        this.listener = listener || jscape.domain.AddTradingPartnerController.LISTENER;
        this.managementService = managementService;
        this.domainName = domainName;
        this.deferred = $.Deferred();
        this._setupDialog().show(this);
        return this.deferred.promise();
    },

    onTestServer: function(partner) {
        this.listener.onTestPartner(partner);
    },

    onSubmit: function(dialog) {
        var protocol = dialog.getProtocol();
        dialog.destroy();

        var theClass = this.controllerMap[protocol];
        var controller = new theClass(this.resources);
        controller.start(this, this.managementService, this.domainName)
                .done($.proxy(this._storePartner, this))
                .fail(this.deferred.reject);
    },

    onCancel: function(dialog) {
        dialog.destroy();
        this.deferred.reject();
    },

    _setupDialog: function() {
        return new jscape.domain.AddTradingPartnerProtocolDialog(this.resources);
    },

    _storePartner: function (partner) {
        this.managementService.storeTradingPartner(this.domainName, partner)
                .done($.proxy(function () { this.deferred.resolve(partner); }, this))
                .fail(this.deferred.reject);
    }
});
jscape.domain.AddTradingPartnerController.LISTENER = {
    onTestServer: $.noop
};

/** @class */
jscape.domain.AddTradingPartnerProtocolDialog = Class.extend(
    /** @lends {jscape.domain.AddTradingPartnerProtocolDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this.dialog = $("#d-partner-add-protocol").clone().attr("id", new Date().getTime().toString(36));
        this.dialog.dialog({
            width: 530, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=partnerprotocolfields]", this.dialog);
        this.protocol = $("select[name=protocol]", this.fieldset);
        this.protocol.combobox({required: true, editable: false, width: 150, panelHeight: "auto"});
    },

    getProtocol: function() {
        return this.protocol.combobox("getValue");
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center");
        this.dialog.dialog("open");

        this.fieldset.form("validate");
        this.protocol.combobox("textbox").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.EditTradingPartnerController = Class.extend(
    /** @lends {jscape.domain.EditTradingPartnerController.prototype} */
{
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
        this.controllerMap = {};
        this.controllerMap[jscape.TradingPartner.Protocol.AFTP] = jscape.domain.EditAftpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.AS2] = jscape.domain.EditAs2TradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.AMAZON_S3] = jscape.domain.EditAmazonS3TradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.FTP] = jscape.domain.EditFtpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.FTPS_IMPLICIT] = jscape.domain.EditFtpsImplicitTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.FTPS_EXPLICIT] = jscape.domain.EditFtpsExplicitTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.IMAP] = jscape.domain.EditImapTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.OFTP] = jscape.domain.EditOftpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.POP3] = jscape.domain.EditPop3TradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.REST] = jscape.domain.EditRestTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.SFTP] = jscape.domain.EditSftpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.SMTP] = jscape.domain.EditSmtpTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.WEBDAV] = jscape.domain.EditWebDavTradingPartnerController;
        this.controllerMap[jscape.TradingPartner.Protocol.TFTP] = jscape.domain.EditTftpTradingPartnerController;
    },

    start: function(listener, managementService, domainName, partner) {
        this.listener = listener || jscape.domain.EditTradingPartnerController.LISTENER;
        this.managementService = managementService;
        this.domainName = domainName;
        this.deferred = $.Deferred();

        var theClass = this.controllerMap[partner.protocol];
        var controller = new theClass(this.resources);
        controller.start(this, this.managementService, this.domainName, partner)
                        .done($.proxy(this._storePartner, this))
                        .fail(this.deferred.reject);

        return this.deferred.promise();
    },

    onTestServer: function(partner) {
        this.listener.onTestPartner(partner);
    },

    _storePartner: function (partner) {
        this.managementService.storeTradingPartner(this.domainName, partner)
                .done($.proxy(function () { this.deferred.resolve(partner); }, this))
                .fail(this.deferred.reject);
    }
});
jscape.domain.EditTradingPartnerController.LISTENER = {
    onTestServer: $.noop
};


/** @class */
jscape.domain.DeleteTradingPartnerController = Class.extend(
    /** @lends {jscape.domain.DeleteTradingPartnerController.prototype} */
{
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
    },

    start: function (managementService, domainName, items) {
        this.managementService = managementService;
        this.domainName = domainName;
        this.deferred = $.Deferred();

        this._confirmDelete(items)
                .done($.proxy(this._deleteConfirmed, this, items))
                .fail(this.deferred.reject);

        return this.deferred.promise();
    },

    _confirmDelete: function(items) {
        var text = $.map(items, function(proxy) { return proxy.name; }).join(", ");
        return jscape.ConfirmDialog.confirm(
                this.resources.getString("TRADING_PARTNERS_CONFIRM_DELETE_TITLE"),
                this.resources.getString("TRADING_PARTNERS_CONFIRM_DELETE_MESSAGE", {0: text}));
    },

    _deleteConfirmed: function(items) {
        var promises = new Array(items.length);
        for (var i = 0; i < items.length; i++) {
            promises[i] = this.managementService.deleteTradingPartner(this.domainName, items[i].name);
        }

        $.when.apply(jQuery, promises)
                .done($.proxy(this.deferred.resolve, this.deferred, items))
                .fail(this.deferred.reject);
    }
});

/** @class */
jscape.domain.TestTradingPartnerController = Class.extend(
    /** @lends {jscape.domain.TestTradingPartnerController.prototype} */
{
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
    },

    start: function(managementService, domainName, partner) {
        this.managementService = managementService;
        this.domainName = domainName;
        this.deferred = $.Deferred();

        this.managementService.testTradingPartner(this.domainName, partner)
                        .done($.proxy(this._testPassed, this))
                        .fail($.proxy(this._testFailed, this));

        return this.deferred.promise();
    },

    _testPassed: function() {
        $.messager.alert(this.resources.getString("TRADING_PARTNERS_TEST_TITLE"),
                         this.resources.getString("TRADING_PARTNERS_TEST_PASSED"),
                         "info");
        this.deferred.resolve();
    },

    _testFailed: function() {
        this.deferred.reject();
    }
});

/** @class */
jscape.domain.CopyTradingPartnerController = Class.extend(
    /** @lends {jscape.domain.CopyTradingPartnerController.prototype} */
{
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
    },

    start: function(managementService, domainName, partnerName) {
        this.managementService = managementService;
        this.domainName = domainName;
        this.partnerName = partnerName;
        this.deferred = $.Deferred();
        this._setupDialog().show(this);
        return this.deferred.promise();
    },

    onSubmit: function(dialog) {
        var newName = dialog.getNewPartnerName();
        dialog.destroy();

        this.managementService.copyTradingPartner(this.domainName, this.partnerName, newName)
                .done($.proxy(function(partner) { this.deferred.resolve(partner); this.deferred = null; }, this))
                .fail($.proxy(function() { this.deferred.reject(); this.deferred = null; }, this));
    },

    onCancel: function(dialog) {
        dialog.destroy();
        this.deferred.reject();
        this.deferred = null;
    },

    _setupDialog: function() {
        var dialog = new jscape.domain.CopyTradingPartnerDialog(this.resources);
        dialog.setPartnerName(this.partnerName);
        return dialog
    }
});

/** @class */
jscape.domain.CopyTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.CopyTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this.dialog = $("#d-partner-copy").clone().attr("id", "");
        this.dialog.dialog({
            width: 530, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.title = this.dialog.dialog("header").text();
        this.fieldset = $("fieldset[name=copytradingpartnerfields]", this.dialog);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getNewPartnerName: function() {
        return this.name.val();
    },

    setPartnerName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this.name.focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.ClientKeyController = Class.extend(
    /** @lends {jscape.domain.ClientKeyController.prototype} */
{
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
    },

    start: function(managementService, domainName, keyProvider) {
        this.managementService = managementService;
        this.domainName = domainName;
        this.deferred= $.Deferred();

        this._setupDialog(keyProvider).show(this);

        return this.deferred.promise();
    },

    onSubmit: function(dialog) {
        var provider = this._createKeyProvider(dialog);
        dialog.destroy();
        this.deferred.resolve(provider);
    },

    onCancel: function(dialog) {
        dialog.destroy();
        this.deferred.reject();
    },

    onSelectKeyFile: function(dialog) {
        var loadFn = $.proxy(this.managementService.listKeystorePath, this.managementService);
        var createFn = $.proxy(this.managementService.createKeystoreDir, this.managementService);
        new SelectPathController(loadFn, createFn).selectFile(function(entry) { dialog.setKeyFile(entry.path); });
    },

    _setupDialog: function(keyProvider) {
        var dialog = new jscape.domain.ClientKeyDialog(this.resources);
        if (keyProvider instanceof jscape.FileKeyProvider) {
            dialog.setUseFile(keyProvider.file, keyProvider.filePassword);
        } else {
            dialog.setUseNone();
        }

        this.managementService.getServerKeys()
                .done($.proxy(function(keys) {
                    dialog.setServerKeys($.map(keys, function(key) { return key.alias; }));
                    if (keyProvider instanceof jscape.ServerKeyProvider) {
                        dialog.setServerKey(keyProvider.keyAlias);
                    }
                }, this));

        return dialog;
    },

    _createKeyProvider: function(dialog) {
        if (dialog.isUseServerKey()) {
            return new jscape.ServerKeyProvider(dialog.getServerKey());
        } else if (dialog.isUseFile()) {
            return new jscape.FileKeyProvider(dialog.getKeyFile(), dialog.getKeyFilePassword());
        }
        return null;
    }
});

/** @class */
jscape.domain.ClientKeyDialog = Class.extend(
    /** @lends {jscape.domain.ClientKeyDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this.dialog = $("#d-partner-clientkeys").clone().attr("id", "");
        this.dialog.dialog({
            width: 580, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=partnerclientkeyfields]", this.dialog);
        this.types = $("input[name=type]:radio", this.fieldset);
        this.typeNone = this.types.filter("[value=none]");
        this.typeServerKey = this.types.filter("[value=serverkey]");
        this.typeKeyFile = this.types.filter("[value=keyfile]");
        this.types.change($.proxy(this._adjustFieldState, this));

        this.serverKey = $("select[name=serverkey]", this.fieldset);
        this.serverKey.combobox({required: true, editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function() {
            var data = this.serverKey.combobox("getData");
            if (data.length != 0) {
                this.serverKey.combobox("setValue", data[0].value);
            } else {
                this.serverKey.combobox("disable");
            }
            this.typeServerKey.prop("disabled", data.length == 0);
        }, this)});

        this.keyFile = $("input[name=keyfile]", this.fieldset);
        this.keyFile.validatebox({required: true, validType: "partner_keyfile_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_KEY_FILE")});
        this.keyFilePassword = $("input[name=keyfilepwd]", this.fieldset);
        this.browseKeyFile = $("a[role=button][name=browsekeyfile]", this.fieldset);
        this.browseKeyFile.linkbutton({disabled: true, onClick: $.proxy(this._onClick$BrowseKeyFile, this)});
    },

    isUseNone: function() {
        return this.typeNone.is(":checked");
    },

    setUseNone: function() {
        this.typeNone.prop("checked", true).change();
    },

    isUseServerKey: function() {
        return this.typeServerKey.is(":checked");
    },

    getServerKey: function() {
        return this.isUseServerKey() ? this.serverKey.combobox("getValue") : null;
    },

    setServerKey: function(value) {
        this.serverKey.combobox("select", value);
        this.typeServerKey.prop("checked", value != null).change();
    },

    setServerKeys: function(values) {
        values = $.map(values || [], function(value) { return {text: value, value: value}; });
        this.serverKey.combobox("loadData", values);
    },

    isUseFile: function() {
        return this.typeKeyFile.is(":checked");
    },

    setUseFile: function(file, filepwd) {
        this.typeKeyFile.prop("checked", true).change();
        this.keyFile.val(file);
        this.keyFilePassword.val(filepwd);
    },

    getKeyFile: function() {
        return this.keyFile.val();
    },

    setKeyFile: function(value) {
        this.keyFile.val(value).validatebox("validate");
    },

    getKeyFilePassword: function() {
        return this.keyFilePassword.val();
    },

    show: function (listener) {
        this.listener = listener || jscape.domain.ClientKeyDialog.LISTENER;
        this.dialog.dialog("center");
        this.dialog.dialog("open");

        this.fieldset.form("validate");
        this.dialog.find(".dialog-button input:first").focus();
        this._adjustFieldState();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$BrowseKeyFile: function() {
        this.listener.onSelectKeyFile(this);
    },

    _adjustFieldState: function() {
        var useKeyFile = this.isUseFile();
        var useServerKey = this.isUseServerKey();
        this.serverKey.combobox(useServerKey ? "enable" : "disable");
        this.keyFile.prop("disabled", !useKeyFile).validatebox(useKeyFile ? "enableValidation" : "disableValidation").validatebox("validate");
        this.keyFilePassword.prop("disabled", !useKeyFile);
        this.browseKeyFile.linkbutton(useKeyFile ? "enable" : "disable");
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});
jscape.domain.ClientKeyDialog.LISTENER = {
    onSelectKeyFile: $.noop
};

/** @class */
jscape.domain.BaseTradingPartnerController = Class.extend(
    /** @lends {jscape.domain.BaseTradingPartnerController.prototype} */
{
    clientKeyProvider: null,
    deferred: null,

    /** @constructor */
    initialize: function(resources) {
        this.resources = resources;
        this.clientKeyController = new jscape.domain.ClientKeyController(this.resources);
    },

    start: function(listener, managementService, domainName, keyProvider) {
        this.listener = listener || jscape.domain.BaseTradingPartnerController.LISTENER;
        this.managementService = managementService;
        this.domainName = domainName;
        this.clientKeyProvider = keyProvider || null;
        this.deferred = $.Deferred();
        this._setupDialog().show(this);
        return this.deferred.promise();
    },

    onSubmit: function(dialog) {
        var descriptor = this._createPartner(dialog);
        dialog.destroy();
        this.deferred.resolve(descriptor);
        this.deferred = null;
    },

    onCancel: function(dialog) {
        dialog.destroy();
        this.deferred.reject();
        this.deferred = null;
    },

    onTest: function(dialog) {
        this.listener.onTestServer(this._createPartner(dialog));
    },

    onSelectClientKey: function() {
        this.clientKeyController.start(this.managementService, this.domainName, this.clientKeyProvider)
                .done($.proxy(function(provider) { this.clientKeyProvider = provider; }, this));
    },

    _loadHostKeys: function () {
        return this.managementService.getHostCertificates()
                .then(function(certificates) {
                    return $.map(certificates || [], function (certificate) { return certificate.alias; });
                });
    },

    _setupDialog: function() {
        throw "not implemented";
    },

    _createPartner: function (dialog) {
        throw "not implemented";
    }
});
jscape.domain.BaseReverseProxyController.LISTENER = {
    onTestServer: $.noop
};

/** @class */
jscape.domain.AddAftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddAftpTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 3000,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddAftpTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys(dialog)
                .done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.aftp(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null);
    }
});

/** @class */
jscape.domain.EditAftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditAftpTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditAftpTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        this._loadHostKeys()
                .done($.proxy(function(keys) {
                    dialog.setHostKeys(keys);
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.aftp(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null);
    }
});

/** @class */
jscape.domain.AftpTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.AftpTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("select", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return this.port.numberspinner("getValue");
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center");
        this.dialog.dialog("open");

        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddAftpTradingPartnerDialog = jscape.domain.AftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddAftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-aftp"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditAftpTradingPartnerDialog = jscape.domain.AftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditAftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-aftp"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddAmazonS3TradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddAmazonS3TradingPartnerController.prototype} */
{
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddAmazonS3TradingPartnerDialog(this.resources);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        return  dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.amazonS3(dialog.getName(),
                                              dialog.getCompany(),
                                              dialog.getEmail(),
                                              dialog.getTimeout(),
                                              dialog.getUsername(),
                                              dialog.getPassword(),
                                              dialog.isEncryptionRequired());
    }
});

/** @class */
jscape.domain.EditAmazonS3TradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditAmazonS3TradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName);
    },

    _setupDialog: function() {
        var dialog = new jscape.domain.EditAmazonS3TradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setEncryptionRequired(this.partner.encryptionRequired);
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.amazonS3(this.partner.name,
                                              dialog.getCompany(),
                                              dialog.getEmail(),
                                              dialog.getTimeout(),
                                              dialog.getUsername(),
                                              dialog.getPassword(),
                                              dialog.isEncryptionRequired());
    }
});

/** @class */
jscape.domain.AmazonS3TradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.AmazonS3TradingPartnerDialog.prototype} */
{
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.encryptionRequired = $("input[name=encrypt]:checkbox", this.fieldset);

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR).numberspinner("validate");
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    isEncryptionRequired: function() {
        return this.encryptionRequired.is(":checked");
    },

    setEncryptionRequired: function(value) {
        this.encryptionRequired.prop("checked", !!value);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddAmazonS3TradingPartnerDialog = jscape.domain.AmazonS3TradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddAmazonS3TradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-amazons3"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditAmazonS3TradingPartnerDialog = jscape.domain.AmazonS3TradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditAmazonS3TradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-amazons3"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddAs2TradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddAs2TradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_TIMEOUT: 30 * 1000,
    RECEIPT_TIMEOUT: 5 * 60 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddAs2TradingPartnerDialog(this.resources);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        dialog.setReceiptAwaitingTimeout(this.RECEIPT_TIMEOUT);
        dialog.setSignatureAlgorithms(jscape.SignatureAlgorithm.values());
        dialog.setReceiptHttpsRequired(true);
        dialog.setReceiptSignatureRequired(true);
        this._loadHostKeys(dialog);
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.as2(dialog.getName(),
                                         dialog.getCompany(),
                                         dialog.getEmail(),
                                         dialog.getUrl(),
                                         dialog.getTimeout(),
                                         dialog.getUsername(),
                                         dialog.getPassword(),
                                         this.clientKeyProvider,
                                         this._serverKeyProviderFor(dialog.getHostKey()),
                                         dialog.isUseCompression(),
                                         dialog.getSender(),
                                         dialog.getRecipient(),
                                         dialog.getReceiptType(),
                                         dialog.isReceiptHttpsRequired(),
                                         dialog.isReceiptSignatureRequired(),
                                         dialog.getReceiptAwaitingTimeout(),
                                         this._serverKeyProviderFor(dialog.getEncryptionKey()),
                                         dialog.getEncryptionAlgorithm(),
                                         this._serverKeyProviderFor(dialog.getSigningKey()),
                                         dialog.getSignatureAlgorithm());
    },

    /** @override */
    _loadHostKeys: function (dialog) {
        $.when(this.managementService.getHostCertificates(), this.managementService.getServerKeys())
                .done(function (certificates, serverKeys) {
                          var hostKeyAliases = $.map(certificates || [], function (certificate) { return certificate.alias; });
                          dialog.setHostKeys(hostKeyAliases);
                          dialog.setEncryptionKeys(hostKeyAliases);
                          dialog.setSigningKeys(serverKeys);
                      });
    },

    _serverKeyProviderFor: function(keyAlias) {
        return keyAlias != null ? new jscape.ServerKeyProvider(keyAlias) : null;
    }
});

/** @class */
jscape.domain.EditAs2TradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditAs2TradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditAs2TradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setUrl(this.partner.url);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setUseCompression(this.partner.as2CompressionRequired);
        dialog.setSender(this.partner.as2Sender);
        dialog.setRecipient(this.partner.as2Recipient);
        dialog.setReceiptType(this.partner.as2ReceiptType);
        dialog.setReceiptHttpsRequired(this.partner.as2ReceiptHttpsRequired);
        dialog.setReceiptSignatureRequired(this.partner.as2ReceiptSignatureRequired);
        dialog.setReceiptAwaitingTimeout(this.partner.as2ReceiptAwaitingTimeout);
        this._loadHostKeys(dialog);
        return dialog;
    },

    /** @override */
    _loadHostKeys: function (dialog) {
        var partner = this.partner;
        var hostKey = this._serverKeyProviderAlias(partner.hostKeyProvider);
        var encryptionKey = this._serverKeyProviderAlias(partner.encryptionKeyProvider);
        var signingKey = this._serverKeyProviderAlias(partner.signingKeyProvider);

        return $.when(this.managementService.getHostCertificates(), this.managementService.getServerKeys())
                .done(function (certificates, serverKeys) {
                          var hostKeyAliases = $.map(certificates || [], function (certificate) { return certificate.alias; });
                          dialog.setHostKeys(hostKeyAliases);
                          dialog.setHostKey(hostKey);
                          dialog.setEncryptionKeys(hostKeyAliases);
                          dialog.setEncryptionKey(encryptionKey);
                          dialog.setEncryptionAlgorithm(partner.encryptionAlgorithm);
                          dialog.setSigningKeys(serverKeys);
                          dialog.setSigningKey(signingKey);
                          dialog.setSignatureAlgorithm(partner.signatureAlgorithm);
                      });
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.as2(this.partner.name,
                                         dialog.getCompany(),
                                         dialog.getEmail(),
                                         dialog.getUrl(),
                                         dialog.getTimeout(),
                                         dialog.getUsername(),
                                         dialog.getPassword(),
                                         this.clientKeyProvider,
                                         this._serverKeyProviderFor(dialog.getHostKey()),
                                         dialog.isUseCompression(),
                                         dialog.getSender(),
                                         dialog.getRecipient(),
                                         dialog.getReceiptType(),
                                         dialog.isReceiptHttpsRequired(),
                                         dialog.isReceiptSignatureRequired(),
                                         dialog.getReceiptAwaitingTimeout(),
                                         this._serverKeyProviderFor(dialog.getEncryptionKey()),
                                         dialog.getEncryptionAlgorithm(),
                                         this._serverKeyProviderFor(dialog.getSigningKey()),
                                         dialog.getSignatureAlgorithm());
    },

    _serverKeyProviderFor: function(keyAlias) {
        return keyAlias != null ? new jscape.ServerKeyProvider(keyAlias) : null;
    },

    _serverKeyProviderAlias: function(keyProvider) {
        return keyProvider && keyProvider.keyAlias ? keyProvider.keyAlias : null;
    }
});

/** @class */
jscape.domain.As2TradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.As2TradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,
    RECEIPT_TIMEOUT_FACTOR: 60 * 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.resources = resources;

        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 680, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.url = $("input[name=url]", this.fieldset);
        this.url.validatebox({required: true, validType: "partner_url", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_URL")});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("setValue", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.sender = $("input[name=sender]", this.fieldset);
        this.sender.validatebox({required: true, validType: "partner_sender", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_SENDER")});

        this.recipient = $("input[name=recipient]", this.fieldset);
        this.recipient.validatebox({required: true, validType: "partner_recipient", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_RECIPIENT")});

        this.receiptType = $("select[name=receipt]", this.fieldset);
        this.receiptType.combobox({required: true, editable: false, width: 170, panelHeight: "auto"});

        this.receiptHttpsRequired = $("input[name=usereceiptssl]:checkbox", this.fieldset);
        this.receiptSignatureRequired = $("input[name=usereceipsignature]:checkbox", this.fieldset);

        this.receipTimeout = $("input[name=receiptimeout]", this.fieldset);
        this.receipTimeout.numberspinner({required: true, min: 1, max: 1000, width: 90});

        this.useEncryptKey = $("input[name=useencryptkey]:checkbox", this.fieldset);
        this.useEncryptKey.change($.proxy(function() {
            var enabled = this.useEncryptKey.is(":checked");
            this.encryptKey.combobox(enabled ? "enable" : "disable");
            this.encryptAlgorithm.combobox(enabled ? "enable" : "disable");
        }, this));
        this.encryptKey = $("select[name=encryptkey]", this.fieldset);
        this.encryptKey.combobox({
            editable: false, disabled: true,
            width: 170, panelHeight: "auto",
            onLoadSuccess: $.proxy(function(data) {
                if (data.length != 0) {
                    this.encryptKey.combobox("select", data[0].value);
                } else {
                    this.useEncryptKey.prop("disabled", true).prop("checked", false);
                }
                this.useEncryptKey.change();
            }, this)});
        this.encryptAlgorithm = $("select[name=encryptalgorithm]", this.fieldset);
        this.encryptAlgorithm.combobox({editable: false, width: 170, panelHeight: "auto"});

        this.useSignKey = $("input[name=usesigningkey]:checkbox", this.fieldset);
        this.useSignKey.change($.proxy(function () {
            var enabled = this.useSignKey.is(":checked");
            this.signKey.combobox(enabled ? "enable" : "disable");
            this.signatureAlgorithm.combobox(enabled ? "enable" : "disable");
        }, this));
        this.signKey = $("select[name=signingkey]", this.fieldset);
        this.signKey.combobox({
            editable: false, disabled: true,
            width: 170, panelHeight: "auto",
            valueField:"alias", textField: "alias",
            onChange: $.proxy(this._adjustSignatureAlgorithms, this),
            onLoadSuccess: $.proxy(function (data) {
                if (data.length != 0) {
                    this.signKey.combobox("reset").combobox("select", data[0].alias);
                } else {
                    this.useSignKey.prop("disabled", true).prop("checked", false).change();
                }
        }, this)});
        this.signatureAlgorithm = $("select[name=signalgorithm]", this.fieldset);
        this.signatureAlgorithm.combobox({editable: false, disabled: true, valueField: "name", textField: "displayName", width: 170, panelHeight: "auto"});

        this.useCompression = $("input[name=usecompression]", this.fieldset);

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getUrl: function() {
        return this.url.val();
    },

    setUrl: function(value) {
        this.url.val(value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    getSender: function() {
        return this.sender.val();
    },

    setSender: function(value) {
        this.sender.val(value);
    },

    getRecipient: function() {
        return this.recipient.val();
    },

    setRecipient: function(value) {
        this.recipient.val(value);
    },

    getReceiptType: function() {
        return this.receiptType.combobox("getValue");
    },

    setReceiptType: function(value) {
        this.receiptType.combobox("setValue", value);
    },

    isReceiptHttpsRequired: function() {
        return this.receiptHttpsRequired.is(":checked");
    },

    setReceiptHttpsRequired: function(value) {
        this.receiptHttpsRequired.prop("checked", !!value);
    },

    isReceiptSignatureRequired: function() {
        return this.receiptSignatureRequired.is(":checked");
    },

    setReceiptSignatureRequired: function(value) {
        this.receiptSignatureRequired.prop("checked", !!value);
    },

    getReceiptAwaitingTimeout: function() {
        return this.receipTimeout.numberspinner("getValue") * this.RECEIPT_TIMEOUT_FACTOR;
    },

    setReceiptAwaitingTimeout: function(value) {
        this.receipTimeout.numberspinner("setValue", parseInt(value) / this.RECEIPT_TIMEOUT_FACTOR);
    },

    getEncryptionKey: function() {
        return this.useEncryptKey.is(":checked") ? this.encryptKey.combobox("getValue") : null;
    },

    setEncryptionKey: function(value) {
        this.useEncryptKey.prop("checked", value != null).change();
        if (value != null) {
            this.encryptKey.combobox("select", value);
        }
    },

    setEncryptionKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.encryptKey.combobox("loadData", values);
    },

    getEncryptionAlgorithm: function() {
        return this.encryptAlgorithm.combobox("getValue");
    },

    setEncryptionAlgorithm: function(value) {
        this.encryptAlgorithm.combobox("setValue", value);
    },

    getSigningKey: function() {
        return this.useSignKey.is(":checked") ? this.signKey.combobox("getValue") : null;
    },

    setSigningKey: function(value) {
        this.useSignKey.prop("checked", value != null).change();
        if (value != null) {
            this.signKey.combobox("setValue", value);
        }
    },

    setSigningKeys: function(values) {
        this.signKey.combobox("loadData", values);
    },

    getSignatureAlgorithm: function() {
        return this.signatureAlgorithm.combobox("getValue");
    },

    setSignatureAlgorithm: function(value) {
        window.console.log("As2TradingPartnerDialog.setSignatureAlgorithm" + value);
        this.signatureAlgorithm.combobox("reset").combobox("select", value);
    },

    setSignatureAlgorithms: function (values) {
        var template = this.resources.getString("TRADING_PARTNERS_SIGNATURE_TEMPLATE");
        var data = $.map(values || [], function (item) { return $.extend({displayName: template.supplant({0: item.hashAlgorithm, 1: item.asymmetricalAlgorithm})}, item); });
        this.signatureAlgorithm.combobox("loadData", data);
    },

    isUseCompression: function() {
        return this.useCompression.is(":checked");
    },

    setUseCompression: function(value) {
        this.useCompression.prop("checked", !!value);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");

        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    },

    _adjustSignatureAlgorithms: function () {
        var alias = this.signKey.combobox("getValue");
        var data = this.signKey.combobox("getData");
        for (var i = 0; i < data.length; i++) {
            if (data[i].alias == alias) {
                window.console.log("As2TradingPartnerDialog._adjustSignatureAlgorithms");
                this.setSignatureAlgorithms(jscape.SignatureAlgorithm.algorithmsOf(data[i].algorithm));
                break;
            }
        }
    }
});

/** @class */
jscape.domain.AddAs2TradingPartnerDialog = jscape.domain.As2TradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddAs2TradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-as2"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditAs2TradingPartnerDialog = jscape.domain.As2TradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditAs2TradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-as2"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddFtpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddFtpTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 21,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddFtpTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.ftp(dialog.getName(),
                                         dialog.getCompany(),
                                         dialog.getEmail(),
                                         dialog.getHost(),
                                         dialog.getPort(),
                                         dialog.getTimeout(),
                                         dialog.getUsername(),
                                         dialog.getPassword(),
                                         dialog.getPostLoginCommand());
    }
});

/** @class */
jscape.domain.EditFtpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditFtpTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditFtpTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setPostLoginCommand(this.partner.ftpPostLoginCommand);
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.ftp(this.partner.name,
                                         dialog.getCompany(),
                                         dialog.getEmail(),
                                         dialog.getHost(),
                                         dialog.getPort(),
                                         dialog.getTimeout(),
                                         dialog.getUsername(),
                                         dialog.getPassword(),
                                         dialog.getPostLoginCommand());
    }
});

/** @class */
jscape.domain.FtpTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.FtpTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.postLoginCommand = $("input[name=postlogincmd]", this.fieldset);

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return this.port.numberspinner("getValue");
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getPostLoginCommand: function() {
        return this.postLoginCommand.val();
    },

    setPostLoginCommand: function(value) {
        this.postLoginCommand.val(value);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center");
        this.dialog.dialog("open");

        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddFtpTradingPartnerDialog = jscape.domain.FtpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddFtpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-ftp"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditFtpTradingPartnerDialog = jscape.domain.FtpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditFtpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-ftp"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddFtpsImplicitTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddFtpsImplicitTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 990,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddFtpsTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys()
                .done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.ftpsImplicit(dialog.getName(),
                                                  dialog.getCompany(),
                                                  dialog.getEmail(),
                                                  dialog.getHost(),
                                                  dialog.getPort(),
                                                  dialog.getTimeout(),
                                                  dialog.getUsername(),
                                                  dialog.getPassword(),
                                                  this.clientKeyProvider,
                                                  dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                                  dialog.getPostLoginCommand());
    }
});

/** @class */
jscape.domain.EditFtpsImplicitTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditFtpsImplicitTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditFtpsTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setPostLoginCommand(this.partner.ftpPostLoginCommand);
        this._loadHostKeys()
                .done($.proxy(function(keys) {
                    dialog.setHostKeys(keys);
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.ftpsImplicit(this.partner.name,
                                                  dialog.getCompany(),
                                                  dialog.getEmail(),
                                                  dialog.getHost(),
                                                  dialog.getPort(),
                                                  dialog.getTimeout(),
                                                  dialog.getUsername(),
                                                  dialog.getPassword(),
                                                  this.clientKeyProvider,
                                                  dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                                  dialog.getPostLoginCommand());
    }
});

/** @class */
jscape.domain.AddFtpsExplicitTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddFtpsExplicitTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 21,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddFtpsTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys()
                .done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.ftpsExplicit(dialog.getName(),
                                                  dialog.getCompany(),
                                                  dialog.getEmail(),
                                                  dialog.getHost(),
                                                  dialog.getPort(),
                                                  dialog.getTimeout(),
                                                  dialog.getUsername(),
                                                  dialog.getPassword(),
                                                  this.clientKeyProvider,
                                                  dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                                  dialog.getPostLoginCommand());
    }
});

/** @class */
jscape.domain.EditFtpsExplicitTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditFtpsExplicitTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditFtpsTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setPostLoginCommand(this.partner.ftpPostLoginCommand);
        this._loadHostKeys()
                .done($.proxy(function(keys) {
                    dialog.setHostKeys(keys);
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.ftpsExplicit(this.partner.name,
                                                  dialog.getCompany(),
                                                  dialog.getEmail(),
                                                  dialog.getHost(),
                                                  dialog.getPort(),
                                                  dialog.getTimeout(),
                                                  dialog.getUsername(),
                                                  dialog.getPassword(),
                                                  this.clientKeyProvider,
                                                  dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                                  dialog.getPostLoginCommand());
    }
});

/** @class */
jscape.domain.FtpsTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.FtpsTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("select", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.postLoginCommand = $("input[name=postlogincmd]", this.fieldset);

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return this.port.numberspinner("getValue");
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    getPostLoginCommand: function() {
        return this.postLoginCommand.val();
    },

    setPostLoginCommand: function(value) {
        this.postLoginCommand.val(value);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center");
        this.dialog.dialog("open");

        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddFtpsTradingPartnerDialog = jscape.domain.FtpsTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddFtpsTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-ftps"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditFtpsTradingPartnerDialog = jscape.domain.FtpsTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditFtpsTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-ftps"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});
/** @class */
jscape.domain.AddOftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddOftpTradingPartnerController.prototype} */
{
    DEFAULT_PORT: 3305,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddOftpTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadKeys()
                .done(function (hostKeys, encryptionKeys, signgingKeys) {
                          dialog.setHostKeys($.map(hostKeys, function(key) { return key.alias; }));
                          dialog.setEncryptionKeys($.map(encryptionKeys, function(key) { return key.alias; }));
                          dialog.setSigningKeys($.map(signgingKeys, function(key) { return key.alias; }));
                      });
        return dialog;
    },

    _createPartner: function(dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        var encryptionKeyProvider = dialog.getEncryptionKey() != null ? new jscape.ServerKeyProvider(dialog.getEncryptionKey()) : null;
        var signingKeyProvider = dialog.getSigningKey() != null ? new jscape.ServerKeyProvider(dialog.getSigningKey()) : null;
        return jscape.TradingPartner.oftp(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider,
                                          dialog.getRecipient(),
                                          encryptionKeyProvider,
                                          signingKeyProvider,
                                          dialog.isUseSsl(),
                                          dialog.getCipher());
    },

    _loadKeys: function () {
        return $.when(this.managementService.getHostCertificates(),
                      this.managementService.getServerKeys())
                .then(function (hostCertificates, serverKeys) {
                          var encryptionKeys = $.grep(hostCertificates, function (key) { return "RSA" == key.algorithm; });
                          var signingKeys = $.grep(serverKeys || [], function (key) { return "RSA" == key.algorithm; });
                          return $.Deferred().resolve(hostCertificates, encryptionKeys, signingKeys);
                      });
    }
});

/** @class */
jscape.domain.EditOftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditOftpTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditOftpTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUseSsl(this.partner.encryptionRequired);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setRecipient(this.partner.oftpDestination);
        dialog.setCipher(this.partner.cipherSuite);
        this._loadKeys()
                .done($.proxy(function(hostKeys, encryptionKeys, signingKeys) {
                    dialog.setHostKeys($.map(hostKeys, function(key) { return key.alias; }));
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                    dialog.setEncryptionKeys($.map(encryptionKeys, function(key) { return key.alias; }));
                    dialog.setEncryptionKey(this.partner.encryptionKeyProvider ? this.partner.encryptionKeyProvider.keyAlias : null);
                    dialog.setSigningKeys($.map(signingKeys, function(key) { return key.alias; }));
                    dialog.setSigningKey(this.partner.signingKeyProvider ? this.partner.signingKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        var encryptionKeyProvider = dialog.getEncryptionKey() != null ? new jscape.ServerKeyProvider(dialog.getEncryptionKey()) : null;
        var signingKeyProvider = dialog.getSigningKey() != null ? new jscape.ServerKeyProvider(dialog.getSigningKey()) : null;
        return jscape.TradingPartner.oftp(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider,
                                          dialog.getRecipient(),
                                          encryptionKeyProvider,
                                          signingKeyProvider,
                                          dialog.isUseSsl(),
                                          dialog.getCipher());
    },

    _loadKeys: function () {
        return $.when(this.managementService.getHostCertificates(),
                      this.managementService.getServerKeys())
                .then(function (hostCertificates, serverKeys) {
                          var encryptionKeys = $.grep(hostCertificates, function (key) { return "RSA" == key.algorithm; });
                          var signingKeys = $.grep(serverKeys || [], function (key) { return "RSA" == key.algorithm; });
                          return $.Deferred().resolve(hostCertificates, encryptionKeys, signingKeys);
                      });
    }
});

/** @class */
jscape.domain.OftpTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.OftpTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 1000, increment: 10, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.ssl = $("input[name=usessl]:checkbox", this.fieldset);

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("select", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.recipient = $("input[name=recipient]", this.fieldset);
        this.recipient.validatebox({required: true, missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_RECIPIENT")});

        this.useEncryptionKey = $("input[name=useencryptionkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useEncryptionKey.change($.proxy(function () {
            this.encryptionKey.combobox(this.useEncryptionKey.is(":checked") ? "enable" : "disable");
            this._adjustCipherFieldState();
        }, this));
        this.encryptionKey = $("select[name=encryptionkey]", this.fieldset);
        this.encryptionKey.combobox({
            editable: false,
            disabled: true,
            width: 170,
            panelHeight: "auto",
            onLoadSuccess: $.proxy(function (data) {
                this.useEncryptionKey.prop("disabled", data.length == 0);
                if (data.length != 0) {
                    this.encryptionKey.combobox("select", data[0].value);
                }
            }, this)
        });

        this.useSigningKey = $("input[name=usesigningkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useSigningKey.change($.proxy(function () {
            this.signingKey.combobox(this.useSigningKey.is(":checked") ? "enable" : "disable");
            this._adjustCipherFieldState();
        }, this));
        this.signingKey = $("select[name=signingkey]", this.fieldset);
        this.signingKey.combobox({
            editable: false,
            disabled: true,
            width: 170,
            panelHeight: "auto",
            onLoadSuccess: $.proxy(function (data) {
                this.useSigningKey.prop("disabled", data.length == 0);
                if (data.length != 0) {
                    this.signingKey.combobox("select", data[0].value);
                }
            }, this)
        });

        this.cipher = $("select[name=cipher]", this.fieldset);
        this.cipher.combobox({required: true, editable: false, panelHeight: "auto"});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return this.port.numberspinner("getValue");
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    isUseSsl: function() {
        return this.ssl.is(":checked");
    },

    setUseSsl: function(value) {
        this.ssl.prop("checked", !!value);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    getRecipient: function() {
        return this.recipient.val();
    },

    setRecipient: function(value) {
        this.recipient.val(value);
    },

    getEncryptionKey: function() {
        return this.useEncryptionKey.is(":checked") ? this.encryptionKey.combobox("getValue") : null;
    },

    setEncryptionKey: function(value) {
        this.useEncryptionKey.prop("checked", value != null).change();
        if (value != null) {
            this.encryptionKey.combobox("setValue", value);
        }
    },

    setEncryptionKeys: function (values) {
        values = $.map(values, function (value) { return {text: value, value: value}; });
        this.encryptionKey.combobox("loadData", values);
    },

    getSigningKey: function() {
        return this.useSigningKey.is(":checked") ? this.signingKey.combobox("getValue") : null;
    },

    setSigningKey: function(value) {
        this.useSigningKey.prop("checked", value != null).change();
        if (value != null) {
            this.signingKey.combobox("setValue", value);
        }
    },

    setSigningKeys: function (values) {
        values = $.map(values, function (value) { return {text: value, value: value}; });
        this.signingKey.combobox("loadData", values);
    },

    getCipher: function() {
        return this.cipher.is(":disabled") ? null : this.cipher.combobox("getValue");
    },

    setCipher: function(value) {
        this.cipher.combobox("select", value);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this._adjustCipherFieldState();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _adjustCipherFieldState: function(){
        this.cipher.combobox(this.getEncryptionKey() != null || this.getSigningKey() != null ? "enable" : "disable");
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddOftpTradingPartnerDialog = jscape.domain.OftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddOftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-oftp"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditOftpTradingPartnerDialog = jscape.domain.OftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditOftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-oftp"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddSftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddSftpTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 22,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddSftpTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys()
                .done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.sftp(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                          dialog.isStartSubsystemReplyRequired());
    }
});

/** @class */
jscape.domain.EditSftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditSftpTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditSftpTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setStartSubsystemReplyRequired(this.partner.sftpStartSubsystemReplyRequired);
        this._loadHostKeys()
                .done($.proxy(function(keys) {
                    dialog.setHostKeys(keys);
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.sftp(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                          dialog.isStartSubsystemReplyRequired());
    }
});

/** @class */
jscape.domain.SftpTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.SftpTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("select", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.startSubsystemReply = $("input[name=startsubsystemreply]:checkbox", this.fieldset);

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return this.port.numberspinner("getValue");
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    isStartSubsystemReplyRequired: function() {
        return this.startSubsystemReply.is(":checked");
    },

    setStartSubsystemReplyRequired: function(value) {
        this.startSubsystemReply.prop("checked", !!value);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center");
        this.dialog.dialog("open");

        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddSftpTradingPartnerDialog = jscape.domain.SftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddSftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-sftp"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditSftpTradingPartnerDialog = jscape.domain.SftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditSftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-sftp"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddWebDavTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddWebDavTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddWebDavTradingPartnerDialog(this.resources);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys()
                .done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.webdav(dialog.getName(),
                                            dialog.getCompany(),
                                            dialog.getEmail(),
                                            dialog.getUrl(),
                                            dialog.getTimeout(),
                                            dialog.getUsername(),
                                            dialog.getPassword(),
                                            dialog.getDomain(),
                                            this.clientKeyProvider,
                                            dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null);
    }
});

/** @class */
jscape.domain.EditWebDavTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditWebDavTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditWebDavTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setUrl(this.partner.url);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setDomain(this.partner.domain);
        this._loadHostKeys()
                .done($.proxy(function(keys) {
                    dialog.setHostKeys(keys);
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.webdav(this.partner.name,
                                            dialog.getCompany(),
                                            dialog.getEmail(),
                                            dialog.getUrl(),
                                            dialog.getTimeout(),
                                            dialog.getUsername(),
                                            dialog.getPassword(),
                                            dialog.getDomain(),
                                            this.clientKeyProvider,
                                            dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null);
    }
});

/** @class */
jscape.domain.WebDavTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.WebDavTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.url = $("input[name=url]", this.fieldset);
        this.url.validatebox({required: true, validType: "partner_url", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_URL")});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);
        this.domain = $("input[name=domain]", this.fieldset);
        this.domain.validatebox({required: true});

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("select", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getUrl: function() {
        return this.url.val();
    },

    setUrl: function(value) {
        this.url.val(value);
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getDomain: function() {
        return this.domain.val();
    },

    setDomain: function(value) {
        this.domain.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddWebDavTradingPartnerDialog = jscape.domain.WebDavTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddWebDavTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-webdav"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditWebDavTradingPartnerDialog = jscape.domain.WebDavTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditWebDavTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-webdav"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddRestTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddRestTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 80,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddRestTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys()
                .done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.rest(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          dialog.getDomain(),
                                          this.clientKeyProvider,
                                          dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                          dialog.isUseSsl());
    }
});

/** @class */
jscape.domain.EditRestTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditRestTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditRestTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        dialog.setDomain(this.partner.domain);
        dialog.setUseSsl(this.partner.encryptionRequired);
        this._loadHostKeys()
                .done($.proxy(function(keys) {
                    dialog.setHostKeys(keys);
                    dialog.setHostKey(this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null);
                }, this));
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.rest(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          dialog.getDomain(),
                                          this.clientKeyProvider,
                                          dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null,
                                          dialog.isUseSsl());
    }
});

/** @class */
jscape.domain.RestTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.RestTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.useSsl = $("input[name=ssl]:checkbox", this.fieldset);

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);
        this.domain = $("input[name=domain]", this.fieldset);
        this.domain.validatebox({required: true});

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("select", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return parseInt(this.port.numberspinner("getValue"));
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", parseInt(value)).numberspinner("validate");
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    isUseSsl: function() {
        return this.useSsl.is(":checked");
    },

    setUseSsl: function(value) {
        this.useSsl.prop("checked", !!value);
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getDomain: function() {
        return this.domain.val();
    },

    setDomain: function(value) {
        this.domain.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddRestTradingPartnerDialog = jscape.domain.RestTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddRestTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-rest"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditRestTradingPartnerDialog = jscape.domain.RestTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditRestTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-rest"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddTftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddTftpTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 69,
    DEFAULT_INTERVAL: 3 * 1000,
    DEFAULT_ATTEMPTS: 6,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddTftpTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setRetransmitInterval(this.DEFAULT_INTERVAL);
        dialog.setMaxRetransmitAttempts(this.DEFAULT_ATTEMPTS);
        return dialog;
    },

    _createPartner: function(dialog) {
        return jscape.TradingPartner.tftp(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getRetransmitInterval()/*,
                                          dialog.getMaxRetransmitAttempts()*/);
    }
});

/** @class */
jscape.domain.EditTftpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditTftpTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditTftpTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setRetransmitInterval(this.partner.timeout);
        dialog.setMaxRetransmitAttempts(/*this.partner.maxRetransmitAttempts*/6);
        return dialog;
    },

    _createPartner: function (dialog) {
        return jscape.TradingPartner.tftp(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getRetransmitInterval()/*,
                                          dialog.getMaxRetransmitAttempts()*/);
    }
});

/** @class */
jscape.domain.TftpTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.TftpTradingPartnerDialog.prototype} */
{
    /** @const */
    TIME_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.retransmitInterval = $("input[name=retransmitinterval]", this.fieldset);
        this.retransmitInterval.numberspinner({required: true, min: 1, max: 255, width: 60});

        this.retransmitAttempts = $("input[name=retransmitattempts]", this.fieldset);
        this.retransmitAttempts.numberspinner({required: true, min: 1, max: 100, width: 60});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return parseInt(this.port.numberspinner("getValue"));
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", parseInt(value)).numberspinner("validate");
    },

    getRetransmitInterval: function() {
        return parseInt(this.retransmitInterval.numberspinner("getValue")) * this.TIME_FACTOR;
    },

    setRetransmitInterval: function(value) {
        this.retransmitInterval.numberspinner("setValue", parseInt(value) / this.TIME_FACTOR).numberspinner("validate");
    },

    getMaxRetransmitAttempts: function() {
        return parseInt(this.retransmitAttempts.numberspinner("getValue"));
    },

    setMaxRetransmitAttempts: function(value) {
        this.retransmitAttempts.numberspinner("setValue", parseInt(value)).numberspinner("validate");
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddTftpTradingPartnerDialog = jscape.domain.TftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddTftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-tftp"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditTftpTradingPartnerDialog = jscape.domain.TftpTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditTftpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-tftp"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddImapTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddImapTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 143,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddImapTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys().done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        return jscape.TradingPartner.imap(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getConnectionType(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider);
    }
});

/** @class */
jscape.domain.EditImapTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditImapTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditImapTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setConnectionType(this.partner.connectionType);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        var hostKey = this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null;
        this._loadHostKeys().done(function(keys) {
            dialog.setHostKeys(keys);
            dialog.setHostKey(hostKey);
        });
        return dialog;
    },

    _createPartner: function (dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        return jscape.TradingPartner.imap(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getConnectionType(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider);
    }
});

/** @class */
jscape.domain.AddPop3TradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddPop3TradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 110,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddPop3TradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys().done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        return jscape.TradingPartner.pop3(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getConnectionType(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider);
    }
});

/** @class */
jscape.domain.EditPop3TradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditPop3TradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditPop3TradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setConnectionType(this.partner.connectionType);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        var hostKey = this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null;
        this._loadHostKeys().done(function(keys) {
            dialog.setHostKeys(keys);
            dialog.setHostKey(hostKey);
        });
        return dialog;
    },

    _createPartner: function (dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        return jscape.TradingPartner.pop3(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getConnectionType(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider);
    }
});

/** @class */
jscape.domain.AddSmtpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.AddSmtpTradingPartnerController.prototype} */
{
    /** @const */
    DEFAULT_PORT: 25,
    DEFAULT_TIMEOUT: 30 * 1000,

    _setupDialog: function() {
        var dialog = new jscape.domain.AddSmtpTradingPartnerDialog(this.resources);
        dialog.setPort(this.DEFAULT_PORT);
        dialog.setTimeout(this.DEFAULT_TIMEOUT);
        this._loadHostKeys().done(function(keys) { dialog.setHostKeys(keys); });
        return dialog;
    },

    _createPartner: function(dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        return jscape.TradingPartner.smtp(dialog.getName(),
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getConnectionType(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider);
    }
});

/** @class */
jscape.domain.EditSmtpTradingPartnerController = jscape.domain.BaseTradingPartnerController.extend(
    /** @lends {jscape.domain.EditSmtpTradingPartnerController.prototype} */
{
    /** @override */
    start: function(listener, managementService, domainName, partner) {
        this.partner = partner;
        return this._super(listener, managementService, domainName, partner.keyProvider);
    },

    _setupDialog: function () {
        var dialog = new jscape.domain.EditSmtpTradingPartnerDialog(this.resources);
        dialog.setName(this.partner.name);
        dialog.setCompany(this.partner.company);
        dialog.setEmail(this.partner.email);
        dialog.setHost(this.partner.host);
        dialog.setPort(this.partner.port);
        dialog.setTimeout(this.partner.timeout);
        dialog.setConnectionType(this.partner.connectionType);
        dialog.setUsername(this.partner.username);
        dialog.setPassword(this.partner.password);
        var hostKey = this.partner.hostKeyProvider ? this.partner.hostKeyProvider.keyAlias : null;
        this._loadHostKeys().done(function(keys) {
            dialog.setHostKeys(keys);
            dialog.setHostKey(hostKey);
        });
        return dialog;
    },

    _createPartner: function (dialog) {
        var hostKeyProvider = dialog.getHostKey() != null ? new jscape.ServerKeyProvider(dialog.getHostKey()) : null;
        return jscape.TradingPartner.smtp(this.partner.name,
                                          dialog.getCompany(),
                                          dialog.getEmail(),
                                          dialog.getHost(),
                                          dialog.getPort(),
                                          dialog.getTimeout(),
                                          dialog.getConnectionType(),
                                          dialog.getUsername(),
                                          dialog.getPassword(),
                                          this.clientKeyProvider,
                                          hostKeyProvider);
    }
});

/** @class */
jscape.domain.MailAccessTradingPartnerDialog = Class.extend(
    /** @lends {jscape.domain.MailAccessTradingPartnerDialog.prototype} */
{
    /** @const */
    TIMEOUT_FACTOR: 1000,

    /** @constructor */
    initialize: function(dialog, resources) {
        this.dialog = dialog.clone().attr("id", "");
        this.dialog.dialog({
            width: 650, height: "auto",
            modal: true, resizable: false, closable: true, closed: true,
            buttons: [
                {text: resources.getString("DIALOG_BUTTON_OK") || "Ok", handler: $.proxy(this._onSubmit, this)},
                {text: resources.getString("DIALOG_BUTTON_CANCEL") || "Cancel", handler: $.proxy(this._onCancel, this)}
            ],
            onClose: $.proxy(function () {if (!this.closing) { this._onCancel(); }}, this)
        }).show();

        this.fieldset = $("fieldset[name=tradingpartnerfields]", this.dialog);

        this.company = $("input[name=company]", this.fieldset);
        this.email = $("input[name=email]", this.fieldset);
        this.email.validatebox({required: false, validType: "multi_value['email',',']"});

        this.host = $("input[name=host]", this.fieldset);
        this.host.validatebox({required: true, validType: "partner_host_nonempty", missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_HOST")});

        this.port = $("input[name=port]", this.fieldset);
        this.port.numberspinner({required: true, min: 1, max: 65535, width: 100});

        this.timeout = $("input[name=timeout]", this.fieldset);
        this.timeout.numberspinner({required: true, min: 1, max: 60, width: 60});

        this.connectionType = $("select[name=connectiontype]", this.fieldset);
        this.connectionType.combobox({required: true, editable: false, panelHeight: "auto"});

        this.username = $("input[name=username]", this.fieldset);
        this.password = $("input[name=password]", this.fieldset);

        this.useHostKey = $("input[name=usehostkey]:checkbox", this.fieldset).prop("disabled", true);
        this.useHostKey.change($.proxy(function() {
            this.hostKey.combobox(this.useHostKey.is(":checked") ? "enable" : "disable");
        }, this));
        this.hostKey = $("select[name=hostkey]", this.fieldset);
        this.hostKey.combobox({editable: false, disabled: true, width: 170, panelHeight: "auto", onLoadSuccess: $.proxy(function(data) {
            this.useHostKey.prop("disabled", data.length == 0);
            if (data.length != 0) {
                this.hostKey.combobox("setValue", data[0].value);
            }
        }, this)});

        this.clientKeyButton = $("a[role=button][name=selectclientkey]", this.fieldset);
        this.clientKeyButton.linkbutton({onClick: $.proxy(this._onClick$ClientKeyButton, this)});

        this.testButton = $("a[role=button][name=test]", this.fieldset);
        this.testButton.linkbutton({onClick: $.proxy(this._onClick$TestButton, this)});
    },

    getCompany: function() {
        return this.company.val();
    },

    setCompany: function(value) {
        this.company.val(value);
    },

    getEmail: function() {
        return this.email.val();
    },

    setEmail: function(value) {
        this.email.val(value);
    },

    getHost: function() {
        return this.host.val();
    },

    setHost: function(value) {
        this.host.val(value);
    },

    getPort: function() {
        return parseInt(this.port.numberspinner("getValue"));
    },

    setPort: function(value) {
        this.port.numberspinner("setValue", parseInt(value)).numberspinner("validate");
    },

    getTimeout: function() {
        return this.timeout.numberspinner("getValue") * this.TIMEOUT_FACTOR;
    },

    setTimeout: function(value) {
        this.timeout.numberspinner("setValue", parseInt(value) / this.TIMEOUT_FACTOR);
    },

    getConnectionType: function() {
        return this.connectionType.combobox("getValue");
    },

    setConnectionType: function(value) {
        this.connectionType.combobox("select", value).combobox("validate");
    },

    getUsername: function() {
        return this.username.val();
    },

    setUsername: function(value) {
        this.username.val(value);
    },

    getPassword: function() {
        return this.password.val();
    },

    setPassword: function(value) {
        this.password.val(value);
    },

    getHostKey: function() {
        return this.useHostKey.is(":checked") ? this.hostKey.combobox("getValue") : null;
    },

    setHostKey: function(value) {
        this.useHostKey.prop("checked", value != null).change();
        if (value != null) {
            this.hostKey.combobox("setValue", value);
        }
    },

    setHostKeys: function(values) {
        values = $.map(values, function(value) { return {text: value, value: value}; });
        this.hostKey.combobox("loadData", values);
    },

    show: function (listener) {
        this.listener = listener;
        this.dialog.dialog("center").dialog("open");
        this.fieldset.form("validate");
        this.fieldset.find("input:first").focus();
    },

    hide: function () {
        if (!this._closed()) {
            this.closing = true;
            this.dialog.dialog("close");
            this.fieldset.form("disableValidation");
            this.closing = false;
        }
    },

    destroy: function() {
        this.dialog.dialog("destroy");
    },

    _onClick$ClientKeyButton: function() {
        this.listener.onSelectClientKey();
    },

    _onClick$TestButton: function() {
        if (this.fieldset.form("validate")) {
            this.listener.onTest(this);
        }
    },

    _onSubmit: function () {
        if (this.fieldset.form("validate")) {
            this.hide();
            this.listener.onSubmit(this);
        }
    },

    _onCancel: function () {
        this.hide();
        this.listener.onCancel(this);
    },

    _closed: function () {
        return !!this.dialog.dialog("options").closed;
    }
});

/** @class */
jscape.domain.AddImapTradingPartnerDialog = jscape.domain.MailAccessTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddImapTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-imap"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditImapTradingPartnerDialog = jscape.domain.MailAccessTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditImapTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-imap"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddPop3TradingPartnerDialog = jscape.domain.MailAccessTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddPop3TradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-pop3"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditPop3TradingPartnerDialog = jscape.domain.MailAccessTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditPop3TradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-pop3"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});

/** @class */
jscape.domain.AddSmtpTradingPartnerDialog = jscape.domain.MailAccessTradingPartnerDialog.extend(
    /** @lends {jscape.domain.AddSmtpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-add-smtp"), resources);

        this.name = $("input[name=name]", this.fieldset);
        this.name.validatebox({required: true, validType: ["partner_name_nonempty", "partner_unique"], missingMessage: resources.getString("TRADING_PARTNERS_ERROR_BAD_NAME")});
    },

    getName: function() {
        return this.name.val();
    }
});

/** @class */
jscape.domain.EditSmtpTradingPartnerDialog = jscape.domain.MailAccessTradingPartnerDialog.extend(
    /** @lends {jscape.domain.EditSmtpTradingPartnerDialog.prototype} */
{
    /** @constructor */
    initialize: function(resources) {
        this._super($("#d-partner-edit-smtp"), resources);

        this.title = this.dialog.dialog("header").text() || "";
    },

    setName: function(value) {
        this.dialog.dialog("setTitle", this.title.supplant({0: value}));
    }
});